# -*- encoding: utf-8 -*-
# stub: fog 1.38.0 ruby lib

Gem::Specification.new do |s|
  s.name = "fog"
  s.version = "1.38.0"

  s.required_rubygems_version = Gem::Requirement.new(">= 0") if s.respond_to? :required_rubygems_version=
  s.require_paths = ["lib"]
  s.authors = ["geemus (Wesley Beary)"]
  s.date = "2016-03-28"
  s.description = "The Ruby cloud services library. Supports all major cloud providers including AWS, Rackspace, Linode, Blue Box, StormOnDemand, and many others. Full support for most AWS services including EC2, S3, CloudWatch, SimpleDB, ELB, and RDS."
  s.email = "geemus@gmail.com"
  s.executables = ["fog"]
  s.extra_rdoc_files = ["README.md"]
  s.files = [".document", ".gitignore", ".irbrc", ".rubocop.yml", ".rubocop_todo.yml", ".travis.yml", ".yardopts", "CHANGELOG.md", "CONTRIBUTING.md", "CONTRIBUTORS.md", "Gemfile", "LICENSE.md", "README.md", "RELEASE.md", "Rakefile", "benchs/each_provider.sh", "benchs/each_service.sh", "benchs/fog_vs.rb", "benchs/load_times.rb", "benchs/params.rb", "benchs/parse_vs_push.rb", "bin/fog", "fog.gemspec", "gemfiles/Gemfile-edge", "lib/fog.rb", "lib/fog/aws/service_mapper.rb", "lib/fog/bare_metal_cloud.rb", "lib/fog/bare_metal_cloud/compute.rb", "lib/fog/bare_metal_cloud/core.rb", "lib/fog/bare_metal_cloud/requests/compute/add_server.rb", "lib/fog/bare_metal_cloud/requests/compute/add_server_by_configuration.rb", "lib/fog/bare_metal_cloud/requests/compute/cancel_server.rb", "lib/fog/bare_metal_cloud/requests/compute/get_server.rb", "lib/fog/bare_metal_cloud/requests/compute/list_configurations.rb", "lib/fog/bare_metal_cloud/requests/compute/list_images.rb", "lib/fog/bare_metal_cloud/requests/compute/list_plans.rb", "lib/fog/bare_metal_cloud/requests/compute/list_servers.rb", "lib/fog/bare_metal_cloud/requests/compute/reboot_server.rb", "lib/fog/bin.rb", "lib/fog/bin/aws.rb", "lib/fog/bin/bare_metal_cloud.rb", "lib/fog/bin/bluebox.rb", "lib/fog/bin/brightbox.rb", "lib/fog/bin/clodo.rb", "lib/fog/bin/cloudsigma.rb", "lib/fog/bin/cloudstack.rb", "lib/fog/bin/digitalocean.rb", "lib/fog/bin/dnsimple.rb", "lib/fog/bin/dnsmadeeasy.rb", "lib/fog/bin/dreamhost.rb", "lib/fog/bin/fogdocker.rb", "lib/fog/bin/glesys.rb", "lib/fog/bin/go_grid.rb", "lib/fog/bin/ibm.rb", "lib/fog/bin/internet_archive.rb", "lib/fog/bin/joyent.rb", "lib/fog/bin/linode.rb", "lib/fog/bin/ninefold.rb", "lib/fog/bin/opennebula.rb", "lib/fog/bin/openstack.rb", "lib/fog/bin/openvz.rb", "lib/fog/bin/ovirt.rb", "lib/fog/bin/rackspace.rb", "lib/fog/bin/rage4.rb", "lib/fog/bin/softlayer.rb", "lib/fog/bin/vcloud.rb", "lib/fog/bin/vcloud_director.rb", "lib/fog/bin/zerigo.rb", "lib/fog/bluebox.rb", "lib/fog/bluebox/blb.rb", "lib/fog/bluebox/compute.rb", "lib/fog/bluebox/core.rb", "lib/fog/bluebox/dns.rb", "lib/fog/bluebox/models/blb/lb_application.rb", "lib/fog/bluebox/models/blb/lb_applications.rb", "lib/fog/bluebox/models/blb/lb_backend.rb", "lib/fog/bluebox/models/blb/lb_backends.rb", "lib/fog/bluebox/models/blb/lb_service.rb", "lib/fog/bluebox/models/blb/lb_services.rb", "lib/fog/bluebox/models/compute/flavor.rb", "lib/fog/bluebox/models/compute/flavors.rb", "lib/fog/bluebox/models/compute/image.rb", "lib/fog/bluebox/models/compute/images.rb", "lib/fog/bluebox/models/compute/location.rb", "lib/fog/bluebox/models/compute/locations.rb", "lib/fog/bluebox/models/compute/server.rb", "lib/fog/bluebox/models/compute/servers.rb", "lib/fog/bluebox/models/dns/record.rb", "lib/fog/bluebox/models/dns/records.rb", "lib/fog/bluebox/models/dns/zone.rb", "lib/fog/bluebox/models/dns/zones.rb", "lib/fog/bluebox/parsers/dns/create_record.rb", "lib/fog/bluebox/parsers/dns/create_zone.rb", "lib/fog/bluebox/parsers/dns/get_record.rb", "lib/fog/bluebox/parsers/dns/get_records.rb", "lib/fog/bluebox/parsers/dns/get_zone.rb", "lib/fog/bluebox/parsers/dns/get_zones.rb", "lib/fog/bluebox/requests/blb/add_machine_to_lb_application.rb", "lib/fog/bluebox/requests/blb/add_machine_to_lb_backend.rb", "lib/fog/bluebox/requests/blb/get_lb_application.rb", "lib/fog/bluebox/requests/blb/get_lb_applications.rb", "lib/fog/bluebox/requests/blb/get_lb_backend.rb", "lib/fog/bluebox/requests/blb/get_lb_backends.rb", "lib/fog/bluebox/requests/blb/get_lb_machine.rb", "lib/fog/bluebox/requests/blb/get_lb_machines.rb", "lib/fog/bluebox/requests/blb/get_lb_service.rb", "lib/fog/bluebox/requests/blb/get_lb_services.rb", "lib/fog/bluebox/requests/blb/remove_machine_from_lb_backend.rb", "lib/fog/bluebox/requests/blb/update_lb_backend_machine.rb", "lib/fog/bluebox/requests/compute/create_block.rb", "lib/fog/bluebox/requests/compute/create_template.rb", "lib/fog/bluebox/requests/compute/destroy_block.rb", "lib/fog/bluebox/requests/compute/destroy_template.rb", "lib/fog/bluebox/requests/compute/get_block.rb", "lib/fog/bluebox/requests/compute/get_blocks.rb", "lib/fog/bluebox/requests/compute/get_location.rb", "lib/fog/bluebox/requests/compute/get_locations.rb", "lib/fog/bluebox/requests/compute/get_product.rb", "lib/fog/bluebox/requests/compute/get_products.rb", "lib/fog/bluebox/requests/compute/get_template.rb", "lib/fog/bluebox/requests/compute/get_templates.rb", "lib/fog/bluebox/requests/compute/reboot_block.rb", "lib/fog/bluebox/requests/dns/create_record.rb", "lib/fog/bluebox/requests/dns/create_zone.rb", "lib/fog/bluebox/requests/dns/delete_record.rb", "lib/fog/bluebox/requests/dns/delete_zone.rb", "lib/fog/bluebox/requests/dns/get_record.rb", "lib/fog/bluebox/requests/dns/get_records.rb", "lib/fog/bluebox/requests/dns/get_zone.rb", "lib/fog/bluebox/requests/dns/get_zones.rb", "lib/fog/bluebox/requests/dns/update_record.rb", "lib/fog/bluebox/requests/dns/update_zone.rb", "lib/fog/clodo.rb", "lib/fog/clodo/compute.rb", "lib/fog/clodo/core.rb", "lib/fog/clodo/models/compute/image.rb", "lib/fog/clodo/models/compute/images.rb", "lib/fog/clodo/models/compute/server.rb", "lib/fog/clodo/models/compute/servers.rb", "lib/fog/clodo/requests/compute/add_ip_address.rb", "lib/fog/clodo/requests/compute/create_server.rb", "lib/fog/clodo/requests/compute/delete_ip_address.rb", "lib/fog/clodo/requests/compute/delete_server.rb", "lib/fog/clodo/requests/compute/get_image_details.rb", "lib/fog/clodo/requests/compute/get_server_details.rb", "lib/fog/clodo/requests/compute/list_images.rb", "lib/fog/clodo/requests/compute/list_images_detail.rb", "lib/fog/clodo/requests/compute/list_servers.rb", "lib/fog/clodo/requests/compute/list_servers_detail.rb", "lib/fog/clodo/requests/compute/move_ip_address.rb", "lib/fog/clodo/requests/compute/reboot_server.rb", "lib/fog/clodo/requests/compute/rebuild_server.rb", "lib/fog/clodo/requests/compute/server_action.rb", "lib/fog/clodo/requests/compute/start_server.rb", "lib/fog/clodo/requests/compute/stop_server.rb", "lib/fog/cloudsigma.rb", "lib/fog/cloudsigma/compute.rb", "lib/fog/cloudsigma/connection.rb", "lib/fog/cloudsigma/core.rb", "lib/fog/cloudsigma/docs/getting_started.md", "lib/fog/cloudsigma/error.rb", "lib/fog/cloudsigma/mock_data.rb", "lib/fog/cloudsigma/models/balance.rb", "lib/fog/cloudsigma/models/current_usage.rb", "lib/fog/cloudsigma/models/fwpolicies.rb", "lib/fog/cloudsigma/models/fwpolicy.rb", "lib/fog/cloudsigma/models/ip.rb", "lib/fog/cloudsigma/models/ipconf.rb", "lib/fog/cloudsigma/models/ips.rb", "lib/fog/cloudsigma/models/lib_volume.rb", "lib/fog/cloudsigma/models/lib_volumes.rb", "lib/fog/cloudsigma/models/mountpoint.rb", "lib/fog/cloudsigma/models/nic.rb", "lib/fog/cloudsigma/models/obj_ref.rb", "lib/fog/cloudsigma/models/price_calculation.rb", "lib/fog/cloudsigma/models/price_record.rb", "lib/fog/cloudsigma/models/pricing.rb", "lib/fog/cloudsigma/models/profile.rb", "lib/fog/cloudsigma/models/rule.rb", "lib/fog/cloudsigma/models/server.rb", "lib/fog/cloudsigma/models/servers.rb", "lib/fog/cloudsigma/models/subscription.rb", "lib/fog/cloudsigma/models/subscriptions.rb", "lib/fog/cloudsigma/models/usage_record.rb", "lib/fog/cloudsigma/models/vlan.rb", "lib/fog/cloudsigma/models/vlans.rb", "lib/fog/cloudsigma/models/volume.rb", "lib/fog/cloudsigma/models/volumes.rb", "lib/fog/cloudsigma/nested_model.rb", "lib/fog/cloudsigma/requests/calculate_subscription_price.rb", "lib/fog/cloudsigma/requests/clone_libvolume.rb", "lib/fog/cloudsigma/requests/clone_server.rb", "lib/fog/cloudsigma/requests/clone_volume.rb", "lib/fog/cloudsigma/requests/close_vnc.rb", "lib/fog/cloudsigma/requests/create_server.rb", "lib/fog/cloudsigma/requests/create_subscription.rb", "lib/fog/cloudsigma/requests/create_volume.rb", "lib/fog/cloudsigma/requests/delete_server.rb", "lib/fog/cloudsigma/requests/delete_volume.rb", "lib/fog/cloudsigma/requests/extend_subscription.rb", "lib/fog/cloudsigma/requests/get_balance.rb", "lib/fog/cloudsigma/requests/get_current_usage.rb", "lib/fog/cloudsigma/requests/get_ip.rb", "lib/fog/cloudsigma/requests/get_lib_volume.rb", "lib/fog/cloudsigma/requests/get_pricing.rb", "lib/fog/cloudsigma/requests/get_profile.rb", "lib/fog/cloudsigma/requests/get_server.rb", "lib/fog/cloudsigma/requests/get_subscription.rb", "lib/fog/cloudsigma/requests/get_vlan.rb", "lib/fog/cloudsigma/requests/get_volume.rb", "lib/fog/cloudsigma/requests/list_fwpolicies.rb", "lib/fog/cloudsigma/requests/list_ips.rb", "lib/fog/cloudsigma/requests/list_lib_volumes.rb", "lib/fog/cloudsigma/requests/list_servers.rb", "lib/fog/cloudsigma/requests/list_subscriptions.rb", "lib/fog/cloudsigma/requests/list_vlans.rb", "lib/fog/cloudsigma/requests/list_volumes.rb", "lib/fog/cloudsigma/requests/open_vnc.rb", "lib/fog/cloudsigma/requests/start_server.rb", "lib/fog/cloudsigma/requests/stop_server.rb", "lib/fog/cloudsigma/requests/update_profile.rb", "lib/fog/cloudsigma/requests/update_server.rb", "lib/fog/cloudsigma/requests/update_vlan.rb", "lib/fog/cloudsigma/requests/update_volume.rb", "lib/fog/cloudstack.rb", "lib/fog/cloudstack/compute.rb", "lib/fog/cloudstack/core.rb", "lib/fog/cloudstack/models/compute/address.rb", "lib/fog/cloudstack/models/compute/disk_offering.rb", "lib/fog/cloudstack/models/compute/disk_offerings.rb", "lib/fog/cloudstack/models/compute/egress_firewall_rule.rb", "lib/fog/cloudstack/models/compute/egress_firewall_rules.rb", "lib/fog/cloudstack/models/compute/firewall_rule.rb", "lib/fog/cloudstack/models/compute/firewall_rules.rb", "lib/fog/cloudstack/models/compute/flavor.rb", "lib/fog/cloudstack/models/compute/flavors.rb", "lib/fog/cloudstack/models/compute/image.rb", "lib/fog/cloudstack/models/compute/images.rb", "lib/fog/cloudstack/models/compute/job.rb", "lib/fog/cloudstack/models/compute/jobs.rb", "lib/fog/cloudstack/models/compute/network.rb", "lib/fog/cloudstack/models/compute/network_offering.rb", "lib/fog/cloudstack/models/compute/network_offerings.rb", "lib/fog/cloudstack/models/compute/networks.rb", "lib/fog/cloudstack/models/compute/port_forwarding_rule.rb", "lib/fog/cloudstack/models/compute/port_forwarding_rules.rb", "lib/fog/cloudstack/models/compute/project.rb", "lib/fog/cloudstack/models/compute/projects.rb", "lib/fog/cloudstack/models/compute/public_ip_address.rb", "lib/fog/cloudstack/models/compute/public_ip_addresses.rb", "lib/fog/cloudstack/models/compute/security_group.rb", "lib/fog/cloudstack/models/compute/security_group_rule.rb", "lib/fog/cloudstack/models/compute/security_group_rules.rb", "lib/fog/cloudstack/models/compute/security_groups.rb", "lib/fog/cloudstack/models/compute/server.rb", "lib/fog/cloudstack/models/compute/servers.rb", "lib/fog/cloudstack/models/compute/snapshot.rb", "lib/fog/cloudstack/models/compute/snapshots.rb", "lib/fog/cloudstack/models/compute/volume.rb", "lib/fog/cloudstack/models/compute/volumes.rb", "lib/fog/cloudstack/models/compute/zone.rb", "lib/fog/cloudstack/models/compute/zones.rb", "lib/fog/cloudstack/requests/compute/acquire_ip_address.rb", "lib/fog/cloudstack/requests/compute/activate_project.rb", "lib/fog/cloudstack/requests/compute/add_account_to_project.rb", "lib/fog/cloudstack/requests/compute/add_baremetal_dhcp.rb", "lib/fog/cloudstack/requests/compute/add_baremetal_host.rb", "lib/fog/cloudstack/requests/compute/add_baremetal_pxe_kick_start_server.rb", "lib/fog/cloudstack/requests/compute/add_baremetal_pxe_ping_server.rb", "lib/fog/cloudstack/requests/compute/add_big_switch_vns_device.rb", "lib/fog/cloudstack/requests/compute/add_cisco_asa1000v_resource.rb", "lib/fog/cloudstack/requests/compute/add_cisco_vnmc_resource.rb", "lib/fog/cloudstack/requests/compute/add_cluster.rb", "lib/fog/cloudstack/requests/compute/add_external_firewall.rb", "lib/fog/cloudstack/requests/compute/add_external_load_balancer.rb", "lib/fog/cloudstack/requests/compute/add_f5_load_balancer.rb", "lib/fog/cloudstack/requests/compute/add_guest_os.rb", "lib/fog/cloudstack/requests/compute/add_guest_os_mapping.rb", "lib/fog/cloudstack/requests/compute/add_host.rb", "lib/fog/cloudstack/requests/compute/add_image_store.rb", "lib/fog/cloudstack/requests/compute/add_ip_to_nic.rb", "lib/fog/cloudstack/requests/compute/add_ldap_configuration.rb", "lib/fog/cloudstack/requests/compute/add_netscaler_load_balancer.rb", "lib/fog/cloudstack/requests/compute/add_network_device.rb", "lib/fog/cloudstack/requests/compute/add_network_service_provider.rb", "lib/fog/cloudstack/requests/compute/add_nic_to_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/add_nicira_nvp_device.rb", "lib/fog/cloudstack/requests/compute/add_open_daylight_controller.rb", "lib/fog/cloudstack/requests/compute/add_palo_alto_firewall.rb", "lib/fog/cloudstack/requests/compute/add_region.rb", "lib/fog/cloudstack/requests/compute/add_resource_detail.rb", "lib/fog/cloudstack/requests/compute/add_s3.rb", "lib/fog/cloudstack/requests/compute/add_secondary_storage.rb", "lib/fog/cloudstack/requests/compute/add_srx_firewall.rb", "lib/fog/cloudstack/requests/compute/add_stratosphere_ssp.rb", "lib/fog/cloudstack/requests/compute/add_swift.rb", "lib/fog/cloudstack/requests/compute/add_traffic_monitor.rb", "lib/fog/cloudstack/requests/compute/add_traffic_type.rb", "lib/fog/cloudstack/requests/compute/add_ucs_manager.rb", "lib/fog/cloudstack/requests/compute/add_vmware_dc.rb", "lib/fog/cloudstack/requests/compute/add_vpn_user.rb", "lib/fog/cloudstack/requests/compute/archive_alerts.rb", "lib/fog/cloudstack/requests/compute/archive_events.rb", "lib/fog/cloudstack/requests/compute/assign_cert_to_load_balancer.rb", "lib/fog/cloudstack/requests/compute/assign_to_global_load_balancer_rule.rb", "lib/fog/cloudstack/requests/compute/assign_to_load_balancer_rule.rb", "lib/fog/cloudstack/requests/compute/assign_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/associate_ip_address.rb", "lib/fog/cloudstack/requests/compute/associate_lun.rb", "lib/fog/cloudstack/requests/compute/associate_ucs_profile_to_blade.rb", "lib/fog/cloudstack/requests/compute/attach_iso.rb", "lib/fog/cloudstack/requests/compute/attach_volume.rb", "lib/fog/cloudstack/requests/compute/authorize_security_group_egress.rb", "lib/fog/cloudstack/requests/compute/authorize_security_group_ingress.rb", "lib/fog/cloudstack/requests/compute/cancel_host_maintenance.rb", "lib/fog/cloudstack/requests/compute/cancel_storage_maintenance.rb", "lib/fog/cloudstack/requests/compute/change_service_for_router.rb", "lib/fog/cloudstack/requests/compute/change_service_for_system_vm.rb", "lib/fog/cloudstack/requests/compute/change_service_for_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/clean_vmreservations.rb", "lib/fog/cloudstack/requests/compute/configure_f5_load_balancer.rb", "lib/fog/cloudstack/requests/compute/configure_internal_load_balancer_element.rb", "lib/fog/cloudstack/requests/compute/configure_netscaler_load_balancer.rb", "lib/fog/cloudstack/requests/compute/configure_ovs_element.rb", "lib/fog/cloudstack/requests/compute/configure_palo_alto_firewall.rb", "lib/fog/cloudstack/requests/compute/configure_srx_firewall.rb", "lib/fog/cloudstack/requests/compute/configure_virtual_router_element.rb", "lib/fog/cloudstack/requests/compute/copy_iso.rb", "lib/fog/cloudstack/requests/compute/copy_template.rb", "lib/fog/cloudstack/requests/compute/create_account.rb", "lib/fog/cloudstack/requests/compute/create_affinity_group.rb", "lib/fog/cloudstack/requests/compute/create_auto_scale_policy.rb", "lib/fog/cloudstack/requests/compute/create_auto_scale_vm_group.rb", "lib/fog/cloudstack/requests/compute/create_auto_scale_vm_profile.rb", "lib/fog/cloudstack/requests/compute/create_condition.rb", "lib/fog/cloudstack/requests/compute/create_counter.rb", "lib/fog/cloudstack/requests/compute/create_disk_offering.rb", "lib/fog/cloudstack/requests/compute/create_domain.rb", "lib/fog/cloudstack/requests/compute/create_egress_firewall_rule.rb", "lib/fog/cloudstack/requests/compute/create_firewall_rule.rb", "lib/fog/cloudstack/requests/compute/create_global_load_balancer_rule.rb", "lib/fog/cloudstack/requests/compute/create_instance_group.rb", "lib/fog/cloudstack/requests/compute/create_internal_load_balancer_element.rb", "lib/fog/cloudstack/requests/compute/create_ip_forwarding_rule.rb", "lib/fog/cloudstack/requests/compute/create_lb_health_check_policy.rb", "lib/fog/cloudstack/requests/compute/create_lb_stickiness_policy.rb", "lib/fog/cloudstack/requests/compute/create_load_balancer.rb", "lib/fog/cloudstack/requests/compute/create_load_balancer_rule.rb", "lib/fog/cloudstack/requests/compute/create_lun_on_filer.rb", "lib/fog/cloudstack/requests/compute/create_network.rb", "lib/fog/cloudstack/requests/compute/create_network_acl.rb", "lib/fog/cloudstack/requests/compute/create_network_acl_list.rb", "lib/fog/cloudstack/requests/compute/create_network_offering.rb", "lib/fog/cloudstack/requests/compute/create_physical_network.rb", "lib/fog/cloudstack/requests/compute/create_pod.rb", "lib/fog/cloudstack/requests/compute/create_pool.rb", "lib/fog/cloudstack/requests/compute/create_port_forwarding_rule.rb", "lib/fog/cloudstack/requests/compute/create_portable_ip_range.rb", "lib/fog/cloudstack/requests/compute/create_private_gateway.rb", "lib/fog/cloudstack/requests/compute/create_project.rb", "lib/fog/cloudstack/requests/compute/create_remote_access_vpn.rb", "lib/fog/cloudstack/requests/compute/create_secondary_staging_store.rb", "lib/fog/cloudstack/requests/compute/create_security_group.rb", "lib/fog/cloudstack/requests/compute/create_service_instance.rb", "lib/fog/cloudstack/requests/compute/create_service_offering.rb", "lib/fog/cloudstack/requests/compute/create_snapshot.rb", "lib/fog/cloudstack/requests/compute/create_snapshot_policy.rb", "lib/fog/cloudstack/requests/compute/create_ssh_key_pair.rb", "lib/fog/cloudstack/requests/compute/create_static_route.rb", "lib/fog/cloudstack/requests/compute/create_storage_network_ip_range.rb", "lib/fog/cloudstack/requests/compute/create_storage_pool.rb", "lib/fog/cloudstack/requests/compute/create_tags.rb", "lib/fog/cloudstack/requests/compute/create_template.rb", "lib/fog/cloudstack/requests/compute/create_user.rb", "lib/fog/cloudstack/requests/compute/create_virtual_router_element.rb", "lib/fog/cloudstack/requests/compute/create_vlan_ip_range.rb", "lib/fog/cloudstack/requests/compute/create_vm_snapshot.rb", "lib/fog/cloudstack/requests/compute/create_volume.rb", "lib/fog/cloudstack/requests/compute/create_volume_on_filer.rb", "lib/fog/cloudstack/requests/compute/create_vpc.rb", "lib/fog/cloudstack/requests/compute/create_vpcoffering.rb", "lib/fog/cloudstack/requests/compute/create_vpn_connection.rb", "lib/fog/cloudstack/requests/compute/create_vpn_customer_gateway.rb", "lib/fog/cloudstack/requests/compute/create_vpn_gateway.rb", "lib/fog/cloudstack/requests/compute/create_zone.rb", "lib/fog/cloudstack/requests/compute/dedicate_cluster.rb", "lib/fog/cloudstack/requests/compute/dedicate_guest_vlan_range.rb", "lib/fog/cloudstack/requests/compute/dedicate_host.rb", "lib/fog/cloudstack/requests/compute/dedicate_pod.rb", "lib/fog/cloudstack/requests/compute/dedicate_public_ip_range.rb", "lib/fog/cloudstack/requests/compute/dedicate_zone.rb", "lib/fog/cloudstack/requests/compute/delete_account.rb", "lib/fog/cloudstack/requests/compute/delete_account_from_project.rb", "lib/fog/cloudstack/requests/compute/delete_affinity_group.rb", "lib/fog/cloudstack/requests/compute/delete_alerts.rb", "lib/fog/cloudstack/requests/compute/delete_auto_scale_policy.rb", "lib/fog/cloudstack/requests/compute/delete_auto_scale_vm_group.rb", "lib/fog/cloudstack/requests/compute/delete_auto_scale_vm_profile.rb", "lib/fog/cloudstack/requests/compute/delete_big_switch_vns_device.rb", "lib/fog/cloudstack/requests/compute/delete_cisco_asa1000v_resource.rb", "lib/fog/cloudstack/requests/compute/delete_cisco_nexus_vsm.rb", "lib/fog/cloudstack/requests/compute/delete_cisco_vnmc_resource.rb", "lib/fog/cloudstack/requests/compute/delete_cluster.rb", "lib/fog/cloudstack/requests/compute/delete_condition.rb", "lib/fog/cloudstack/requests/compute/delete_counter.rb", "lib/fog/cloudstack/requests/compute/delete_disk_offering.rb", "lib/fog/cloudstack/requests/compute/delete_domain.rb", "lib/fog/cloudstack/requests/compute/delete_egress_firewall_rule.rb", "lib/fog/cloudstack/requests/compute/delete_events.rb", "lib/fog/cloudstack/requests/compute/delete_external_firewall.rb", "lib/fog/cloudstack/requests/compute/delete_external_load_balancer.rb", "lib/fog/cloudstack/requests/compute/delete_f5_load_balancer.rb", "lib/fog/cloudstack/requests/compute/delete_firewall_rule.rb", "lib/fog/cloudstack/requests/compute/delete_global_load_balancer_rule.rb", "lib/fog/cloudstack/requests/compute/delete_host.rb", "lib/fog/cloudstack/requests/compute/delete_image_store.rb", "lib/fog/cloudstack/requests/compute/delete_instance_group.rb", "lib/fog/cloudstack/requests/compute/delete_ip_forwarding_rule.rb", "lib/fog/cloudstack/requests/compute/delete_iso.rb", "lib/fog/cloudstack/requests/compute/delete_lb_health_check_policy.rb", "lib/fog/cloudstack/requests/compute/delete_lb_stickiness_policy.rb", "lib/fog/cloudstack/requests/compute/delete_ldap_configuration.rb", "lib/fog/cloudstack/requests/compute/delete_load_balancer.rb", "lib/fog/cloudstack/requests/compute/delete_load_balancer_rule.rb", "lib/fog/cloudstack/requests/compute/delete_netscaler_load_balancer.rb", "lib/fog/cloudstack/requests/compute/delete_network.rb", "lib/fog/cloudstack/requests/compute/delete_network_acl.rb", "lib/fog/cloudstack/requests/compute/delete_network_acl_list.rb", "lib/fog/cloudstack/requests/compute/delete_network_device.rb", "lib/fog/cloudstack/requests/compute/delete_network_offering.rb", "lib/fog/cloudstack/requests/compute/delete_network_service_provider.rb", "lib/fog/cloudstack/requests/compute/delete_nicira_nvp_device.rb", "lib/fog/cloudstack/requests/compute/delete_open_daylight_controller.rb", "lib/fog/cloudstack/requests/compute/delete_palo_alto_firewall.rb", "lib/fog/cloudstack/requests/compute/delete_physical_network.rb", "lib/fog/cloudstack/requests/compute/delete_pod.rb", "lib/fog/cloudstack/requests/compute/delete_pool.rb", "lib/fog/cloudstack/requests/compute/delete_port_forwarding_rule.rb", "lib/fog/cloudstack/requests/compute/delete_portable_ip_range.rb", "lib/fog/cloudstack/requests/compute/delete_private_gateway.rb", "lib/fog/cloudstack/requests/compute/delete_project.rb", "lib/fog/cloudstack/requests/compute/delete_project_invitation.rb", "lib/fog/cloudstack/requests/compute/delete_remote_access_vpn.rb", "lib/fog/cloudstack/requests/compute/delete_secondary_staging_store.rb", "lib/fog/cloudstack/requests/compute/delete_security_group.rb", "lib/fog/cloudstack/requests/compute/delete_service_offering.rb", "lib/fog/cloudstack/requests/compute/delete_snapshot.rb", "lib/fog/cloudstack/requests/compute/delete_snapshot_policies.rb", "lib/fog/cloudstack/requests/compute/delete_srx_firewall.rb", "lib/fog/cloudstack/requests/compute/delete_ssh_key_pair.rb", "lib/fog/cloudstack/requests/compute/delete_ssl_cert.rb", "lib/fog/cloudstack/requests/compute/delete_static_route.rb", "lib/fog/cloudstack/requests/compute/delete_storage_network_ip_range.rb", "lib/fog/cloudstack/requests/compute/delete_storage_pool.rb", "lib/fog/cloudstack/requests/compute/delete_tags.rb", "lib/fog/cloudstack/requests/compute/delete_template.rb", "lib/fog/cloudstack/requests/compute/delete_traffic_monitor.rb", "lib/fog/cloudstack/requests/compute/delete_traffic_type.rb", "lib/fog/cloudstack/requests/compute/delete_ucs_manager.rb", "lib/fog/cloudstack/requests/compute/delete_user.rb", "lib/fog/cloudstack/requests/compute/delete_vlan_ip_range.rb", "lib/fog/cloudstack/requests/compute/delete_vm_snapshot.rb", "lib/fog/cloudstack/requests/compute/delete_volume.rb", "lib/fog/cloudstack/requests/compute/delete_vpc.rb", "lib/fog/cloudstack/requests/compute/delete_vpcoffering.rb", "lib/fog/cloudstack/requests/compute/delete_vpn_connection.rb", "lib/fog/cloudstack/requests/compute/delete_vpn_customer_gateway.rb", "lib/fog/cloudstack/requests/compute/delete_vpn_gateway.rb", "lib/fog/cloudstack/requests/compute/delete_zone.rb", "lib/fog/cloudstack/requests/compute/deploy_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/destroy_lun_on_filer.rb", "lib/fog/cloudstack/requests/compute/destroy_router.rb", "lib/fog/cloudstack/requests/compute/destroy_system_vm.rb", "lib/fog/cloudstack/requests/compute/destroy_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/destroy_volume_on_filer.rb", "lib/fog/cloudstack/requests/compute/detach_iso.rb", "lib/fog/cloudstack/requests/compute/detach_volume.rb", "lib/fog/cloudstack/requests/compute/disable_account.rb", "lib/fog/cloudstack/requests/compute/disable_auto_scale_vm_group.rb", "lib/fog/cloudstack/requests/compute/disable_cisco_nexus_vsm.rb", "lib/fog/cloudstack/requests/compute/disable_static_nat.rb", "lib/fog/cloudstack/requests/compute/disable_user.rb", "lib/fog/cloudstack/requests/compute/disassociate_ip_address.rb", "lib/fog/cloudstack/requests/compute/disassociate_ucs_profile_from_blade.rb", "lib/fog/cloudstack/requests/compute/dissociate_lun.rb", "lib/fog/cloudstack/requests/compute/enable_account.rb", "lib/fog/cloudstack/requests/compute/enable_auto_scale_vm_group.rb", "lib/fog/cloudstack/requests/compute/enable_cisco_nexus_vsm.rb", "lib/fog/cloudstack/requests/compute/enable_static_nat.rb", "lib/fog/cloudstack/requests/compute/enable_storage_maintenance.rb", "lib/fog/cloudstack/requests/compute/enable_user.rb", "lib/fog/cloudstack/requests/compute/expunge_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/extract_iso.rb", "lib/fog/cloudstack/requests/compute/extract_template.rb", "lib/fog/cloudstack/requests/compute/extract_volume.rb", "lib/fog/cloudstack/requests/compute/find_hosts_for_migration.rb", "lib/fog/cloudstack/requests/compute/find_storage_pools_for_migration.rb", "lib/fog/cloudstack/requests/compute/generate_alert.rb", "lib/fog/cloudstack/requests/compute/generate_usage_records.rb", "lib/fog/cloudstack/requests/compute/get_api_limit.rb", "lib/fog/cloudstack/requests/compute/get_cloud_identifier.rb", "lib/fog/cloudstack/requests/compute/get_user.rb", "lib/fog/cloudstack/requests/compute/get_virtual_machine_user_data.rb", "lib/fog/cloudstack/requests/compute/get_vm_password.rb", "lib/fog/cloudstack/requests/compute/import_ldap_users.rb", "lib/fog/cloudstack/requests/compute/instantiate_ucs_template_and_assocaciate_to_blade.rb", "lib/fog/cloudstack/requests/compute/ldap_config.rb", "lib/fog/cloudstack/requests/compute/ldap_create_account.rb", "lib/fog/cloudstack/requests/compute/ldap_remove.rb", "lib/fog/cloudstack/requests/compute/list_accounts.rb", "lib/fog/cloudstack/requests/compute/list_affinity_group_types.rb", "lib/fog/cloudstack/requests/compute/list_affinity_groups.rb", "lib/fog/cloudstack/requests/compute/list_alerts.rb", "lib/fog/cloudstack/requests/compute/list_apis.rb", "lib/fog/cloudstack/requests/compute/list_async_jobs.rb", "lib/fog/cloudstack/requests/compute/list_auto_scale_policies.rb", "lib/fog/cloudstack/requests/compute/list_auto_scale_vm_groups.rb", "lib/fog/cloudstack/requests/compute/list_auto_scale_vm_profiles.rb", "lib/fog/cloudstack/requests/compute/list_baremetal_dhcp.rb", "lib/fog/cloudstack/requests/compute/list_baremetal_pxe_servers.rb", "lib/fog/cloudstack/requests/compute/list_big_switch_vns_devices.rb", "lib/fog/cloudstack/requests/compute/list_capabilities.rb", "lib/fog/cloudstack/requests/compute/list_capacity.rb", "lib/fog/cloudstack/requests/compute/list_cisco_asa1000v_resources.rb", "lib/fog/cloudstack/requests/compute/list_cisco_nexus_vsms.rb", "lib/fog/cloudstack/requests/compute/list_cisco_vnmc_resources.rb", "lib/fog/cloudstack/requests/compute/list_clusters.rb", "lib/fog/cloudstack/requests/compute/list_conditions.rb", "lib/fog/cloudstack/requests/compute/list_configurations.rb", "lib/fog/cloudstack/requests/compute/list_counters.rb", "lib/fog/cloudstack/requests/compute/list_dedicated_clusters.rb", "lib/fog/cloudstack/requests/compute/list_dedicated_guest_vlan_ranges.rb", "lib/fog/cloudstack/requests/compute/list_dedicated_hosts.rb", "lib/fog/cloudstack/requests/compute/list_dedicated_pods.rb", "lib/fog/cloudstack/requests/compute/list_dedicated_zones.rb", "lib/fog/cloudstack/requests/compute/list_deployment_planners.rb", "lib/fog/cloudstack/requests/compute/list_disk_offerings.rb", "lib/fog/cloudstack/requests/compute/list_domain_children.rb", "lib/fog/cloudstack/requests/compute/list_domains.rb", "lib/fog/cloudstack/requests/compute/list_egress_firewall_rules.rb", "lib/fog/cloudstack/requests/compute/list_event_types.rb", "lib/fog/cloudstack/requests/compute/list_events.rb", "lib/fog/cloudstack/requests/compute/list_external_firewalls.rb", "lib/fog/cloudstack/requests/compute/list_external_load_balancers.rb", "lib/fog/cloudstack/requests/compute/list_f5_load_balancer_networks.rb", "lib/fog/cloudstack/requests/compute/list_f5_load_balancers.rb", "lib/fog/cloudstack/requests/compute/list_firewall_rules.rb", "lib/fog/cloudstack/requests/compute/list_global_load_balancer_rules.rb", "lib/fog/cloudstack/requests/compute/list_guest_os_mapping.rb", "lib/fog/cloudstack/requests/compute/list_hosts.rb", "lib/fog/cloudstack/requests/compute/list_hypervisor_capabilities.rb", "lib/fog/cloudstack/requests/compute/list_hypervisors.rb", "lib/fog/cloudstack/requests/compute/list_image_stores.rb", "lib/fog/cloudstack/requests/compute/list_instance_groups.rb", "lib/fog/cloudstack/requests/compute/list_internal_load_balancer_elements.rb", "lib/fog/cloudstack/requests/compute/list_internal_load_balancer_vms.rb", "lib/fog/cloudstack/requests/compute/list_ip_forwarding_rules.rb", "lib/fog/cloudstack/requests/compute/list_iso_permissions.rb", "lib/fog/cloudstack/requests/compute/list_isos.rb", "lib/fog/cloudstack/requests/compute/list_lb_health_check_policies.rb", "lib/fog/cloudstack/requests/compute/list_lb_stickiness_policies.rb", "lib/fog/cloudstack/requests/compute/list_ldap_configurations.rb", "lib/fog/cloudstack/requests/compute/list_ldap_users.rb", "lib/fog/cloudstack/requests/compute/list_load_balancer_rule_instances.rb", "lib/fog/cloudstack/requests/compute/list_load_balancer_rules.rb", "lib/fog/cloudstack/requests/compute/list_load_balancers.rb", "lib/fog/cloudstack/requests/compute/list_luns_on_filer.rb", "lib/fog/cloudstack/requests/compute/list_netscaler_load_balancer_networks.rb", "lib/fog/cloudstack/requests/compute/list_netscaler_load_balancers.rb", "lib/fog/cloudstack/requests/compute/list_network_acl_lists.rb", "lib/fog/cloudstack/requests/compute/list_network_acls.rb", "lib/fog/cloudstack/requests/compute/list_network_device.rb", "lib/fog/cloudstack/requests/compute/list_network_isolation_methods.rb", "lib/fog/cloudstack/requests/compute/list_network_offerings.rb", "lib/fog/cloudstack/requests/compute/list_network_service_providers.rb", "lib/fog/cloudstack/requests/compute/list_networks.rb", "lib/fog/cloudstack/requests/compute/list_nicira_nvp_device_networks.rb", "lib/fog/cloudstack/requests/compute/list_nicira_nvp_devices.rb", "lib/fog/cloudstack/requests/compute/list_nics.rb", "lib/fog/cloudstack/requests/compute/list_open_daylight_controllers.rb", "lib/fog/cloudstack/requests/compute/list_os_categories.rb", "lib/fog/cloudstack/requests/compute/list_os_types.rb", "lib/fog/cloudstack/requests/compute/list_ovs_elements.rb", "lib/fog/cloudstack/requests/compute/list_palo_alto_firewall_networks.rb", "lib/fog/cloudstack/requests/compute/list_palo_alto_firewalls.rb", "lib/fog/cloudstack/requests/compute/list_physical_networks.rb", "lib/fog/cloudstack/requests/compute/list_pods.rb", "lib/fog/cloudstack/requests/compute/list_pools.rb", "lib/fog/cloudstack/requests/compute/list_port_forwarding_rules.rb", "lib/fog/cloudstack/requests/compute/list_portable_ip_ranges.rb", "lib/fog/cloudstack/requests/compute/list_private_gateways.rb", "lib/fog/cloudstack/requests/compute/list_project_accounts.rb", "lib/fog/cloudstack/requests/compute/list_project_invitations.rb", "lib/fog/cloudstack/requests/compute/list_projects.rb", "lib/fog/cloudstack/requests/compute/list_public_ip_addresses.rb", "lib/fog/cloudstack/requests/compute/list_regions.rb", "lib/fog/cloudstack/requests/compute/list_remote_access_vpns.rb", "lib/fog/cloudstack/requests/compute/list_resource_details.rb", "lib/fog/cloudstack/requests/compute/list_resource_limits.rb", "lib/fog/cloudstack/requests/compute/list_routers.rb", "lib/fog/cloudstack/requests/compute/list_s3s.rb", "lib/fog/cloudstack/requests/compute/list_secondary_staging_stores.rb", "lib/fog/cloudstack/requests/compute/list_security_groups.rb", "lib/fog/cloudstack/requests/compute/list_service_offerings.rb", "lib/fog/cloudstack/requests/compute/list_snapshot_policies.rb", "lib/fog/cloudstack/requests/compute/list_snapshots.rb", "lib/fog/cloudstack/requests/compute/list_srx_firewall_networks.rb", "lib/fog/cloudstack/requests/compute/list_srx_firewalls.rb", "lib/fog/cloudstack/requests/compute/list_ssh_key_pairs.rb", "lib/fog/cloudstack/requests/compute/list_ssl_certs.rb", "lib/fog/cloudstack/requests/compute/list_static_routes.rb", "lib/fog/cloudstack/requests/compute/list_storage_network_ip_range.rb", "lib/fog/cloudstack/requests/compute/list_storage_pools.rb", "lib/fog/cloudstack/requests/compute/list_storage_providers.rb", "lib/fog/cloudstack/requests/compute/list_supported_network_services.rb", "lib/fog/cloudstack/requests/compute/list_swifts.rb", "lib/fog/cloudstack/requests/compute/list_system_vms.rb", "lib/fog/cloudstack/requests/compute/list_tags.rb", "lib/fog/cloudstack/requests/compute/list_template_permissions.rb", "lib/fog/cloudstack/requests/compute/list_templates.rb", "lib/fog/cloudstack/requests/compute/list_traffic_monitors.rb", "lib/fog/cloudstack/requests/compute/list_traffic_type_implementors.rb", "lib/fog/cloudstack/requests/compute/list_traffic_types.rb", "lib/fog/cloudstack/requests/compute/list_ucs_blades.rb", "lib/fog/cloudstack/requests/compute/list_ucs_managers.rb", "lib/fog/cloudstack/requests/compute/list_ucs_profiles.rb", "lib/fog/cloudstack/requests/compute/list_ucs_templates.rb", "lib/fog/cloudstack/requests/compute/list_usage_records.rb", "lib/fog/cloudstack/requests/compute/list_usage_types.rb", "lib/fog/cloudstack/requests/compute/list_users.rb", "lib/fog/cloudstack/requests/compute/list_virtual_machines.rb", "lib/fog/cloudstack/requests/compute/list_virtual_router_elements.rb", "lib/fog/cloudstack/requests/compute/list_vlan_ip_ranges.rb", "lib/fog/cloudstack/requests/compute/list_vm_snapshot.rb", "lib/fog/cloudstack/requests/compute/list_vmware_dcs.rb", "lib/fog/cloudstack/requests/compute/list_volumes.rb", "lib/fog/cloudstack/requests/compute/list_volumes_on_filer.rb", "lib/fog/cloudstack/requests/compute/list_vpc_offerings.rb", "lib/fog/cloudstack/requests/compute/list_vpcs.rb", "lib/fog/cloudstack/requests/compute/list_vpn_connections.rb", "lib/fog/cloudstack/requests/compute/list_vpn_customer_gateways.rb", "lib/fog/cloudstack/requests/compute/list_vpn_gateways.rb", "lib/fog/cloudstack/requests/compute/list_vpn_users.rb", "lib/fog/cloudstack/requests/compute/list_zones.rb", "lib/fog/cloudstack/requests/compute/lock_account.rb", "lib/fog/cloudstack/requests/compute/lock_user.rb", "lib/fog/cloudstack/requests/compute/mark_default_zone_for_account.rb", "lib/fog/cloudstack/requests/compute/migrate_system_vm.rb", "lib/fog/cloudstack/requests/compute/migrate_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/migrate_virtual_machine_with_volume.rb", "lib/fog/cloudstack/requests/compute/migrate_volume.rb", "lib/fog/cloudstack/requests/compute/modify_pool.rb", "lib/fog/cloudstack/requests/compute/prepare_host_for_maintenance.rb", "lib/fog/cloudstack/requests/compute/prepare_template.rb", "lib/fog/cloudstack/requests/compute/query_async_job_result.rb", "lib/fog/cloudstack/requests/compute/reboot_router.rb", "lib/fog/cloudstack/requests/compute/reboot_system_vm.rb", "lib/fog/cloudstack/requests/compute/reboot_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/reconnect_host.rb", "lib/fog/cloudstack/requests/compute/recover_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/refresh_ucs_blades.rb", "lib/fog/cloudstack/requests/compute/register_iso.rb", "lib/fog/cloudstack/requests/compute/register_ssh_key_pair.rb", "lib/fog/cloudstack/requests/compute/register_template.rb", "lib/fog/cloudstack/requests/compute/register_user_keys.rb", "lib/fog/cloudstack/requests/compute/release_dedicated_cluster.rb", "lib/fog/cloudstack/requests/compute/release_dedicated_guest_vlan_range.rb", "lib/fog/cloudstack/requests/compute/release_dedicated_host.rb", "lib/fog/cloudstack/requests/compute/release_dedicated_pod.rb", "lib/fog/cloudstack/requests/compute/release_dedicated_zone.rb", "lib/fog/cloudstack/requests/compute/release_host_reservation.rb", "lib/fog/cloudstack/requests/compute/release_public_ip_range.rb", "lib/fog/cloudstack/requests/compute/remove_cert_from_load_balancer.rb", "lib/fog/cloudstack/requests/compute/remove_from_global_load_balancer_rule.rb", "lib/fog/cloudstack/requests/compute/remove_from_load_balancer_rule.rb", "lib/fog/cloudstack/requests/compute/remove_guest_os.rb", "lib/fog/cloudstack/requests/compute/remove_guest_os_mapping.rb", "lib/fog/cloudstack/requests/compute/remove_ip_from_nic.rb", "lib/fog/cloudstack/requests/compute/remove_nic_from_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/remove_region.rb", "lib/fog/cloudstack/requests/compute/remove_resource_detail.rb", "lib/fog/cloudstack/requests/compute/remove_vmware_dc.rb", "lib/fog/cloudstack/requests/compute/remove_vpn_user.rb", "lib/fog/cloudstack/requests/compute/replace_network_acl_list.rb", "lib/fog/cloudstack/requests/compute/reset_api_limit.rb", "lib/fog/cloudstack/requests/compute/reset_password_for_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/reset_ssh_key_for_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/reset_vpn_connection.rb", "lib/fog/cloudstack/requests/compute/resize_volume.rb", "lib/fog/cloudstack/requests/compute/restart_network.rb", "lib/fog/cloudstack/requests/compute/restart_vpc.rb", "lib/fog/cloudstack/requests/compute/restore_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/revert_snapshot.rb", "lib/fog/cloudstack/requests/compute/revert_to_vm_snapshot.rb", "lib/fog/cloudstack/requests/compute/revoke_security_group_egress.rb", "lib/fog/cloudstack/requests/compute/revoke_security_group_ingress.rb", "lib/fog/cloudstack/requests/compute/scale_system_vm.rb", "lib/fog/cloudstack/requests/compute/scale_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/start_internal_load_balancer_vm.rb", "lib/fog/cloudstack/requests/compute/start_router.rb", "lib/fog/cloudstack/requests/compute/start_system_vm.rb", "lib/fog/cloudstack/requests/compute/start_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/stop_internal_load_balancer_vm.rb", "lib/fog/cloudstack/requests/compute/stop_router.rb", "lib/fog/cloudstack/requests/compute/stop_system_vm.rb", "lib/fog/cloudstack/requests/compute/stop_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/suspend_project.rb", "lib/fog/cloudstack/requests/compute/update_account.rb", "lib/fog/cloudstack/requests/compute/update_auto_scale_policy.rb", "lib/fog/cloudstack/requests/compute/update_auto_scale_vm_group.rb", "lib/fog/cloudstack/requests/compute/update_auto_scale_vm_profile.rb", "lib/fog/cloudstack/requests/compute/update_cloud_to_use_object_store.rb", "lib/fog/cloudstack/requests/compute/update_cluster.rb", "lib/fog/cloudstack/requests/compute/update_configuration.rb", "lib/fog/cloudstack/requests/compute/update_default_nic_for_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/update_disk_offering.rb", "lib/fog/cloudstack/requests/compute/update_domain.rb", "lib/fog/cloudstack/requests/compute/update_egress_firewall_rule.rb", "lib/fog/cloudstack/requests/compute/update_firewall_rule.rb", "lib/fog/cloudstack/requests/compute/update_global_load_balancer_rule.rb", "lib/fog/cloudstack/requests/compute/update_guest_os.rb", "lib/fog/cloudstack/requests/compute/update_guest_os_mapping.rb", "lib/fog/cloudstack/requests/compute/update_host.rb", "lib/fog/cloudstack/requests/compute/update_host_password.rb", "lib/fog/cloudstack/requests/compute/update_hypervisor_capabilities.rb", "lib/fog/cloudstack/requests/compute/update_instance_group.rb", "lib/fog/cloudstack/requests/compute/update_ip_address.rb", "lib/fog/cloudstack/requests/compute/update_iso.rb", "lib/fog/cloudstack/requests/compute/update_iso_permissions.rb", "lib/fog/cloudstack/requests/compute/update_lb_health_check_policy.rb", "lib/fog/cloudstack/requests/compute/update_lb_stickiness_policy.rb", "lib/fog/cloudstack/requests/compute/update_load_balancer.rb", "lib/fog/cloudstack/requests/compute/update_load_balancer_rule.rb", "lib/fog/cloudstack/requests/compute/update_network.rb", "lib/fog/cloudstack/requests/compute/update_network_acl_item.rb", "lib/fog/cloudstack/requests/compute/update_network_acl_list.rb", "lib/fog/cloudstack/requests/compute/update_network_offering.rb", "lib/fog/cloudstack/requests/compute/update_network_service_provider.rb", "lib/fog/cloudstack/requests/compute/update_physical_network.rb", "lib/fog/cloudstack/requests/compute/update_pod.rb", "lib/fog/cloudstack/requests/compute/update_port_forwarding_rule.rb", "lib/fog/cloudstack/requests/compute/update_project.rb", "lib/fog/cloudstack/requests/compute/update_project_invitation.rb", "lib/fog/cloudstack/requests/compute/update_region.rb", "lib/fog/cloudstack/requests/compute/update_remote_access_vpn.rb", "lib/fog/cloudstack/requests/compute/update_resource_count.rb", "lib/fog/cloudstack/requests/compute/update_resource_limit.rb", "lib/fog/cloudstack/requests/compute/update_service_offering.rb", "lib/fog/cloudstack/requests/compute/update_storage_network_ip_range.rb", "lib/fog/cloudstack/requests/compute/update_storage_pool.rb", "lib/fog/cloudstack/requests/compute/update_template.rb", "lib/fog/cloudstack/requests/compute/update_template_permissions.rb", "lib/fog/cloudstack/requests/compute/update_traffic_type.rb", "lib/fog/cloudstack/requests/compute/update_user.rb", "lib/fog/cloudstack/requests/compute/update_virtual_machine.rb", "lib/fog/cloudstack/requests/compute/update_vm_affinity_group.rb", "lib/fog/cloudstack/requests/compute/update_volume.rb", "lib/fog/cloudstack/requests/compute/update_vpc.rb", "lib/fog/cloudstack/requests/compute/update_vpcoffering.rb", "lib/fog/cloudstack/requests/compute/update_vpn_connection.rb", "lib/fog/cloudstack/requests/compute/update_vpn_customer_gateway.rb", "lib/fog/cloudstack/requests/compute/update_vpn_gateway.rb", "lib/fog/cloudstack/requests/compute/update_zone.rb", "lib/fog/cloudstack/requests/compute/upgrade_router_template.rb", "lib/fog/cloudstack/requests/compute/upload_custom_certificate.rb", "lib/fog/cloudstack/requests/compute/upload_ssl_cert.rb", "lib/fog/cloudstack/requests/compute/upload_volume.rb", "lib/fog/core/deprecated/connection.rb", "lib/fog/core/parser.rb", "lib/fog/digitalocean.rb", "lib/fog/digitalocean/CHANGELOG.md", "lib/fog/digitalocean/compute_v2.rb", "lib/fog/digitalocean/core.rb", "lib/fog/digitalocean/examples/getting_started.md", "lib/fog/digitalocean/models/compute_v2/flavor.rb", "lib/fog/digitalocean/models/compute_v2/flavors.rb", "lib/fog/digitalocean/models/compute_v2/image.rb", "lib/fog/digitalocean/models/compute_v2/images.rb", "lib/fog/digitalocean/models/compute_v2/region.rb", "lib/fog/digitalocean/models/compute_v2/regions.rb", "lib/fog/digitalocean/models/compute_v2/server.rb", "lib/fog/digitalocean/models/compute_v2/servers.rb", "lib/fog/digitalocean/models/compute_v2/ssh_key.rb", "lib/fog/digitalocean/models/compute_v2/ssh_keys.rb", "lib/fog/digitalocean/models/paging_collection.rb", "lib/fog/digitalocean/requests/compute_v2/change_kernel.rb", "lib/fog/digitalocean/requests/compute_v2/convert_to_snapshot.rb", "lib/fog/digitalocean/requests/compute_v2/create_server.rb", "lib/fog/digitalocean/requests/compute_v2/create_ssh_key.rb", "lib/fog/digitalocean/requests/compute_v2/delete_ssh_key.rb", "lib/fog/digitalocean/requests/compute_v2/destroy_server.rb", "lib/fog/digitalocean/requests/compute_v2/disable_backups.rb", "lib/fog/digitalocean/requests/compute_v2/enable_ipv6.rb", "lib/fog/digitalocean/requests/compute_v2/enable_private_networking.rb", "lib/fog/digitalocean/requests/compute_v2/get_droplet_action.rb", "lib/fog/digitalocean/requests/compute_v2/get_image_details.rb", "lib/fog/digitalocean/requests/compute_v2/get_server_details.rb", "lib/fog/digitalocean/requests/compute_v2/get_ssh_key.rb", "lib/fog/digitalocean/requests/compute_v2/list_droplet_actions.rb", "lib/fog/digitalocean/requests/compute_v2/list_flavors.rb", "lib/fog/digitalocean/requests/compute_v2/list_images.rb", "lib/fog/digitalocean/requests/compute_v2/list_regions.rb", "lib/fog/digitalocean/requests/compute_v2/list_servers.rb", "lib/fog/digitalocean/requests/compute_v2/list_ssh_keys.rb", "lib/fog/digitalocean/requests/compute_v2/password_reset.rb", "lib/fog/digitalocean/requests/compute_v2/power_cycle.rb", "lib/fog/digitalocean/requests/compute_v2/power_off.rb", "lib/fog/digitalocean/requests/compute_v2/power_on.rb", "lib/fog/digitalocean/requests/compute_v2/reboot_server.rb", "lib/fog/digitalocean/requests/compute_v2/rebuild.rb", "lib/fog/digitalocean/requests/compute_v2/rename.rb", "lib/fog/digitalocean/requests/compute_v2/resize.rb", "lib/fog/digitalocean/requests/compute_v2/restore.rb", "lib/fog/digitalocean/requests/compute_v2/shutdown.rb", "lib/fog/digitalocean/requests/compute_v2/snapshot.rb", "lib/fog/digitalocean/requests/compute_v2/transfer_image.rb", "lib/fog/digitalocean/requests/compute_v2/update_ssh_key.rb", "lib/fog/digitalocean/requests/compute_v2/upgrade.rb", "lib/fog/digitalocean/service.rb", "lib/fog/dnsimple.rb", "lib/fog/dnsimple/core.rb", "lib/fog/dnsimple/dns.rb", "lib/fog/dnsimple/models/dns/record.rb", "lib/fog/dnsimple/models/dns/records.rb", "lib/fog/dnsimple/models/dns/zone.rb", "lib/fog/dnsimple/models/dns/zones.rb", "lib/fog/dnsimple/requests/dns/create_domain.rb", "lib/fog/dnsimple/requests/dns/create_record.rb", "lib/fog/dnsimple/requests/dns/delete_domain.rb", "lib/fog/dnsimple/requests/dns/delete_record.rb", "lib/fog/dnsimple/requests/dns/get_domain.rb", "lib/fog/dnsimple/requests/dns/get_record.rb", "lib/fog/dnsimple/requests/dns/list_domains.rb", "lib/fog/dnsimple/requests/dns/list_records.rb", "lib/fog/dnsimple/requests/dns/update_record.rb", "lib/fog/dnsmadeeasy.rb", "lib/fog/dnsmadeeasy/core.rb", "lib/fog/dnsmadeeasy/dns.rb", "lib/fog/dnsmadeeasy/models/dns/record.rb", "lib/fog/dnsmadeeasy/models/dns/records.rb", "lib/fog/dnsmadeeasy/models/dns/zone.rb", "lib/fog/dnsmadeeasy/models/dns/zones.rb", "lib/fog/dnsmadeeasy/requests/dns/create_domain.rb", "lib/fog/dnsmadeeasy/requests/dns/create_record.rb", "lib/fog/dnsmadeeasy/requests/dns/create_secondary.rb", "lib/fog/dnsmadeeasy/requests/dns/delete_all_domains.rb", "lib/fog/dnsmadeeasy/requests/dns/delete_all_secondary.rb", "lib/fog/dnsmadeeasy/requests/dns/delete_domain.rb", "lib/fog/dnsmadeeasy/requests/dns/delete_record.rb", "lib/fog/dnsmadeeasy/requests/dns/delete_secondary.rb", "lib/fog/dnsmadeeasy/requests/dns/get_domain.rb", "lib/fog/dnsmadeeasy/requests/dns/get_record.rb", "lib/fog/dnsmadeeasy/requests/dns/get_secondary.rb", "lib/fog/dnsmadeeasy/requests/dns/list_domains.rb", "lib/fog/dnsmadeeasy/requests/dns/list_records.rb", "lib/fog/dnsmadeeasy/requests/dns/list_secondary.rb", "lib/fog/dnsmadeeasy/requests/dns/update_record.rb", "lib/fog/dnsmadeeasy/requests/dns/update_secondary.rb", "lib/fog/dreamhost.rb", "lib/fog/dreamhost/CHANGELOG.md", "lib/fog/dreamhost/core.rb", "lib/fog/dreamhost/dns.rb", "lib/fog/dreamhost/examples/dns/getting_started.md", "lib/fog/dreamhost/models/dns/record.rb", "lib/fog/dreamhost/models/dns/records.rb", "lib/fog/dreamhost/models/dns/zone.rb", "lib/fog/dreamhost/models/dns/zones.rb", "lib/fog/dreamhost/requests/dns/create_record.rb", "lib/fog/dreamhost/requests/dns/delete_record.rb", "lib/fog/dreamhost/requests/dns/list_records.rb", "lib/fog/fogdocker.rb", "lib/fog/fogdocker/compute.rb", "lib/fog/fogdocker/core.rb", "lib/fog/fogdocker/errors.rb", "lib/fog/fogdocker/models/compute/image.rb", "lib/fog/fogdocker/models/compute/images.rb", "lib/fog/fogdocker/models/compute/server.rb", "lib/fog/fogdocker/models/compute/servers.rb", "lib/fog/fogdocker/requests/compute/api_version.rb", "lib/fog/fogdocker/requests/compute/container_action.rb", "lib/fog/fogdocker/requests/compute/container_all.rb", "lib/fog/fogdocker/requests/compute/container_commit.rb", "lib/fog/fogdocker/requests/compute/container_create.rb", "lib/fog/fogdocker/requests/compute/container_delete.rb", "lib/fog/fogdocker/requests/compute/container_get.rb", "lib/fog/fogdocker/requests/compute/image_all.rb", "lib/fog/fogdocker/requests/compute/image_create.rb", "lib/fog/fogdocker/requests/compute/image_delete.rb", "lib/fog/fogdocker/requests/compute/image_get.rb", "lib/fog/fogdocker/requests/compute/image_search.rb", "lib/fog/glesys.rb", "lib/fog/glesys/compute.rb", "lib/fog/glesys/core.rb", "lib/fog/glesys/models/compute/ip.rb", "lib/fog/glesys/models/compute/ips.rb", "lib/fog/glesys/models/compute/server.rb", "lib/fog/glesys/models/compute/servers.rb", "lib/fog/glesys/models/compute/ssh_key.rb", "lib/fog/glesys/models/compute/ssh_keys.rb", "lib/fog/glesys/models/compute/template.rb", "lib/fog/glesys/models/compute/templates.rb", "lib/fog/glesys/requests/compute/create.rb", "lib/fog/glesys/requests/compute/destroy.rb", "lib/fog/glesys/requests/compute/edit.rb", "lib/fog/glesys/requests/compute/ip_add.rb", "lib/fog/glesys/requests/compute/ip_details.rb", "lib/fog/glesys/requests/compute/ip_list_free.rb", "lib/fog/glesys/requests/compute/ip_list_own.rb", "lib/fog/glesys/requests/compute/ip_release.rb", "lib/fog/glesys/requests/compute/ip_remove.rb", "lib/fog/glesys/requests/compute/ip_take.rb", "lib/fog/glesys/requests/compute/list_servers.rb", "lib/fog/glesys/requests/compute/reboot.rb", "lib/fog/glesys/requests/compute/server_details.rb", "lib/fog/glesys/requests/compute/server_status.rb", "lib/fog/glesys/requests/compute/ssh_key_add.rb", "lib/fog/glesys/requests/compute/ssh_key_list.rb", "lib/fog/glesys/requests/compute/ssh_key_remove.rb", "lib/fog/glesys/requests/compute/start.rb", "lib/fog/glesys/requests/compute/stop.rb", "lib/fog/glesys/requests/compute/template_list.rb", "lib/fog/go_grid.rb", "lib/fog/go_grid/compute.rb", "lib/fog/go_grid/core.rb", "lib/fog/go_grid/models/compute/image.rb", "lib/fog/go_grid/models/compute/images.rb", "lib/fog/go_grid/models/compute/password.rb", "lib/fog/go_grid/models/compute/passwords.rb", "lib/fog/go_grid/models/compute/server.rb", "lib/fog/go_grid/models/compute/servers.rb", "lib/fog/go_grid/requests/compute/common_lookup_list.rb", "lib/fog/go_grid/requests/compute/grid_image_get.rb", "lib/fog/go_grid/requests/compute/grid_image_list.rb", "lib/fog/go_grid/requests/compute/grid_ip_list.rb", "lib/fog/go_grid/requests/compute/grid_loadbalancer_list.rb", "lib/fog/go_grid/requests/compute/grid_server_add.rb", "lib/fog/go_grid/requests/compute/grid_server_delete.rb", "lib/fog/go_grid/requests/compute/grid_server_get.rb", "lib/fog/go_grid/requests/compute/grid_server_list.rb", "lib/fog/go_grid/requests/compute/grid_server_power.rb", "lib/fog/go_grid/requests/compute/support_password_get.rb", "lib/fog/go_grid/requests/compute/support_password_list.rb", "lib/fog/ibm.rb", "lib/fog/ibm/compute.rb", "lib/fog/ibm/core.rb", "lib/fog/ibm/models/compute/address.rb", "lib/fog/ibm/models/compute/addresses.rb", "lib/fog/ibm/models/compute/image.rb", "lib/fog/ibm/models/compute/images.rb", "lib/fog/ibm/models/compute/instance-type.rb", "lib/fog/ibm/models/compute/instance-types.rb", "lib/fog/ibm/models/compute/key.rb", "lib/fog/ibm/models/compute/keys.rb", "lib/fog/ibm/models/compute/location.rb", "lib/fog/ibm/models/compute/locations.rb", "lib/fog/ibm/models/compute/server.rb", "lib/fog/ibm/models/compute/servers.rb", "lib/fog/ibm/models/compute/vlan.rb", "lib/fog/ibm/models/compute/vlans.rb", "lib/fog/ibm/models/storage/offering.rb", "lib/fog/ibm/models/storage/offerings.rb", "lib/fog/ibm/models/storage/volume.rb", "lib/fog/ibm/models/storage/volumes.rb", "lib/fog/ibm/requests/compute/clone_image.rb", "lib/fog/ibm/requests/compute/create_address.rb", "lib/fog/ibm/requests/compute/create_image.rb", "lib/fog/ibm/requests/compute/create_instance.rb", "lib/fog/ibm/requests/compute/create_key.rb", "lib/fog/ibm/requests/compute/delete_address.rb", "lib/fog/ibm/requests/compute/delete_image.rb", "lib/fog/ibm/requests/compute/delete_instance.rb", "lib/fog/ibm/requests/compute/delete_key.rb", "lib/fog/ibm/requests/compute/get_image.rb", "lib/fog/ibm/requests/compute/get_image_agreement.rb", "lib/fog/ibm/requests/compute/get_image_manifest.rb", "lib/fog/ibm/requests/compute/get_instance.rb", "lib/fog/ibm/requests/compute/get_instance_logs.rb", "lib/fog/ibm/requests/compute/get_key.rb", "lib/fog/ibm/requests/compute/get_location.rb", "lib/fog/ibm/requests/compute/get_request.rb", "lib/fog/ibm/requests/compute/list_address_offerings.rb", "lib/fog/ibm/requests/compute/list_addresses.rb", "lib/fog/ibm/requests/compute/list_images.rb", "lib/fog/ibm/requests/compute/list_instances.rb", "lib/fog/ibm/requests/compute/list_keys.rb", "lib/fog/ibm/requests/compute/list_locations.rb", "lib/fog/ibm/requests/compute/list_vlans.rb", "lib/fog/ibm/requests/compute/modify_instance.rb", "lib/fog/ibm/requests/compute/modify_key.rb", "lib/fog/ibm/requests/storage/create_volume.rb", "lib/fog/ibm/requests/storage/delete_volume.rb", "lib/fog/ibm/requests/storage/get_volume.rb", "lib/fog/ibm/requests/storage/list_offerings.rb", "lib/fog/ibm/requests/storage/list_volumes.rb", "lib/fog/ibm/storage.rb", "lib/fog/internet_archive.rb", "lib/fog/internet_archive/core.rb", "lib/fog/internet_archive/models/storage/directories.rb", "lib/fog/internet_archive/models/storage/directory.rb", "lib/fog/internet_archive/models/storage/file.rb", "lib/fog/internet_archive/models/storage/files.rb", "lib/fog/internet_archive/models/storage/ia_attributes.rb", "lib/fog/internet_archive/parsers/storage/access_control_list.rb", "lib/fog/internet_archive/parsers/storage/complete_multipart_upload.rb", "lib/fog/internet_archive/parsers/storage/copy_object.rb", "lib/fog/internet_archive/parsers/storage/cors_configuration.rb", "lib/fog/internet_archive/parsers/storage/delete_multiple_objects.rb", "lib/fog/internet_archive/parsers/storage/get_bucket.rb", "lib/fog/internet_archive/parsers/storage/get_bucket_lifecycle.rb", "lib/fog/internet_archive/parsers/storage/get_bucket_location.rb", "lib/fog/internet_archive/parsers/storage/get_bucket_logging.rb", "lib/fog/internet_archive/parsers/storage/get_bucket_website.rb", "lib/fog/internet_archive/parsers/storage/get_request_payment.rb", "lib/fog/internet_archive/parsers/storage/get_service.rb", "lib/fog/internet_archive/parsers/storage/initiate_multipart_upload.rb", "lib/fog/internet_archive/parsers/storage/list_multipart_uploads.rb", "lib/fog/internet_archive/parsers/storage/list_parts.rb", "lib/fog/internet_archive/requests/storage/abort_multipart_upload.rb", "lib/fog/internet_archive/requests/storage/acl_utils.rb", "lib/fog/internet_archive/requests/storage/complete_multipart_upload.rb", "lib/fog/internet_archive/requests/storage/copy_object.rb", "lib/fog/internet_archive/requests/storage/cors_utils.rb", "lib/fog/internet_archive/requests/storage/delete_bucket.rb", "lib/fog/internet_archive/requests/storage/delete_bucket_cors.rb", "lib/fog/internet_archive/requests/storage/delete_bucket_lifecycle.rb", "lib/fog/internet_archive/requests/storage/delete_bucket_policy.rb", "lib/fog/internet_archive/requests/storage/delete_bucket_website.rb", "lib/fog/internet_archive/requests/storage/delete_multiple_objects.rb", "lib/fog/internet_archive/requests/storage/delete_object.rb", "lib/fog/internet_archive/requests/storage/get_bucket.rb", "lib/fog/internet_archive/requests/storage/get_bucket_acl.rb", "lib/fog/internet_archive/requests/storage/get_bucket_cors.rb", "lib/fog/internet_archive/requests/storage/get_bucket_lifecycle.rb", "lib/fog/internet_archive/requests/storage/get_bucket_location.rb", "lib/fog/internet_archive/requests/storage/get_bucket_logging.rb", "lib/fog/internet_archive/requests/storage/get_bucket_policy.rb", "lib/fog/internet_archive/requests/storage/get_bucket_website.rb", "lib/fog/internet_archive/requests/storage/get_object.rb", "lib/fog/internet_archive/requests/storage/get_object_acl.rb", "lib/fog/internet_archive/requests/storage/get_object_http_url.rb", "lib/fog/internet_archive/requests/storage/get_object_https_url.rb", "lib/fog/internet_archive/requests/storage/get_object_torrent.rb", "lib/fog/internet_archive/requests/storage/get_object_url.rb", "lib/fog/internet_archive/requests/storage/get_request_payment.rb", "lib/fog/internet_archive/requests/storage/get_service.rb", "lib/fog/internet_archive/requests/storage/head_object.rb", "lib/fog/internet_archive/requests/storage/initiate_multipart_upload.rb", "lib/fog/internet_archive/requests/storage/list_multipart_uploads.rb", "lib/fog/internet_archive/requests/storage/list_parts.rb", "lib/fog/internet_archive/requests/storage/post_object_hidden_fields.rb", "lib/fog/internet_archive/requests/storage/put_bucket.rb", "lib/fog/internet_archive/requests/storage/put_bucket_acl.rb", "lib/fog/internet_archive/requests/storage/put_bucket_cors.rb", "lib/fog/internet_archive/requests/storage/put_bucket_lifecycle.rb", "lib/fog/internet_archive/requests/storage/put_bucket_logging.rb", "lib/fog/internet_archive/requests/storage/put_bucket_policy.rb", "lib/fog/internet_archive/requests/storage/put_bucket_website.rb", "lib/fog/internet_archive/requests/storage/put_object.rb", "lib/fog/internet_archive/requests/storage/put_object_acl.rb", "lib/fog/internet_archive/requests/storage/put_object_url.rb", "lib/fog/internet_archive/requests/storage/put_request_payment.rb", "lib/fog/internet_archive/requests/storage/sync_clock.rb", "lib/fog/internet_archive/requests/storage/upload_part.rb", "lib/fog/internet_archive/signaturev4.rb", "lib/fog/internet_archive/storage.rb", "lib/fog/joyent.rb", "lib/fog/joyent/analytics.rb", "lib/fog/joyent/compute.rb", "lib/fog/joyent/core.rb", "lib/fog/joyent/errors.rb", "lib/fog/joyent/models/analytics/field.rb", "lib/fog/joyent/models/analytics/fields.rb", "lib/fog/joyent/models/analytics/instrumentation.rb", "lib/fog/joyent/models/analytics/instrumentations.rb", "lib/fog/joyent/models/analytics/joyent_module.rb", "lib/fog/joyent/models/analytics/joyent_modules.rb", "lib/fog/joyent/models/analytics/metric.rb", "lib/fog/joyent/models/analytics/metrics.rb", "lib/fog/joyent/models/analytics/transformation.rb", "lib/fog/joyent/models/analytics/transformations.rb", "lib/fog/joyent/models/analytics/type.rb", "lib/fog/joyent/models/analytics/types.rb", "lib/fog/joyent/models/analytics/value.rb", "lib/fog/joyent/models/compute/datacenter.rb", "lib/fog/joyent/models/compute/datacenters.rb", "lib/fog/joyent/models/compute/flavor.rb", "lib/fog/joyent/models/compute/flavors.rb", "lib/fog/joyent/models/compute/image.rb", "lib/fog/joyent/models/compute/images.rb", "lib/fog/joyent/models/compute/key.rb", "lib/fog/joyent/models/compute/keys.rb", "lib/fog/joyent/models/compute/network.rb", "lib/fog/joyent/models/compute/networks.rb", "lib/fog/joyent/models/compute/server.rb", "lib/fog/joyent/models/compute/servers.rb", "lib/fog/joyent/models/compute/snapshot.rb", "lib/fog/joyent/models/compute/snapshots.rb", "lib/fog/joyent/requests/analytics/create_instrumentation.rb", "lib/fog/joyent/requests/analytics/delete_instrumentation.rb", "lib/fog/joyent/requests/analytics/describe_analytics.rb", "lib/fog/joyent/requests/analytics/get_instrumentation.rb", "lib/fog/joyent/requests/analytics/get_instrumentation_value.rb", "lib/fog/joyent/requests/analytics/list_instrumentations.rb", "lib/fog/joyent/requests/compute/add_machine_tags.rb", "lib/fog/joyent/requests/compute/create_key.rb", "lib/fog/joyent/requests/compute/create_machine.rb", "lib/fog/joyent/requests/compute/create_machine_snapshot.rb", "lib/fog/joyent/requests/compute/delete_all_machine_metadata.rb", "lib/fog/joyent/requests/compute/delete_all_machine_tags.rb", "lib/fog/joyent/requests/compute/delete_key.rb", "lib/fog/joyent/requests/compute/delete_machine.rb", "lib/fog/joyent/requests/compute/delete_machine_metadata.rb", "lib/fog/joyent/requests/compute/delete_machine_snapshot.rb", "lib/fog/joyent/requests/compute/delete_machine_tag.rb", "lib/fog/joyent/requests/compute/get_dataset.rb", "lib/fog/joyent/requests/compute/get_image.rb", "lib/fog/joyent/requests/compute/get_key.rb", "lib/fog/joyent/requests/compute/get_machine.rb", "lib/fog/joyent/requests/compute/get_machine_metadata.rb", "lib/fog/joyent/requests/compute/get_machine_snapshot.rb", "lib/fog/joyent/requests/compute/get_machine_tag.rb", "lib/fog/joyent/requests/compute/get_package.rb", "lib/fog/joyent/requests/compute/list_datacenters.rb", "lib/fog/joyent/requests/compute/list_datasets.rb", "lib/fog/joyent/requests/compute/list_images.rb", "lib/fog/joyent/requests/compute/list_keys.rb", "lib/fog/joyent/requests/compute/list_machine_snapshots.rb", "lib/fog/joyent/requests/compute/list_machine_tags.rb", "lib/fog/joyent/requests/compute/list_machines.rb", "lib/fog/joyent/requests/compute/list_networks.rb", "lib/fog/joyent/requests/compute/list_packages.rb", "lib/fog/joyent/requests/compute/reboot_machine.rb", "lib/fog/joyent/requests/compute/resize_machine.rb", "lib/fog/joyent/requests/compute/start_machine.rb", "lib/fog/joyent/requests/compute/start_machine_from_snapshot.rb", "lib/fog/joyent/requests/compute/stop_machine.rb", "lib/fog/joyent/requests/compute/update_machine_metadata.rb", "lib/fog/linode.rb", "lib/fog/linode/compute.rb", "lib/fog/linode/core.rb", "lib/fog/linode/dns.rb", "lib/fog/linode/models/compute/data_center.rb", "lib/fog/linode/models/compute/data_centers.rb", "lib/fog/linode/models/compute/disk.rb", "lib/fog/linode/models/compute/disks.rb", "lib/fog/linode/models/compute/flavor.rb", "lib/fog/linode/models/compute/flavors.rb", "lib/fog/linode/models/compute/image.rb", "lib/fog/linode/models/compute/images.rb", "lib/fog/linode/models/compute/ip.rb", "lib/fog/linode/models/compute/ips.rb", "lib/fog/linode/models/compute/kernel.rb", "lib/fog/linode/models/compute/kernels.rb", "lib/fog/linode/models/compute/node_balancer_flavor.rb", "lib/fog/linode/models/compute/node_balancer_flavors.rb", "lib/fog/linode/models/compute/server.rb", "lib/fog/linode/models/compute/servers.rb", "lib/fog/linode/models/compute/stack_script.rb", "lib/fog/linode/models/compute/stack_scripts.rb", "lib/fog/linode/models/dns/record.rb", "lib/fog/linode/models/dns/records.rb", "lib/fog/linode/models/dns/zone.rb", "lib/fog/linode/models/dns/zones.rb", "lib/fog/linode/requests/compute/avail_datacenters.rb", "lib/fog/linode/requests/compute/avail_distributions.rb", "lib/fog/linode/requests/compute/avail_kernels.rb", "lib/fog/linode/requests/compute/avail_linodeplans.rb", "lib/fog/linode/requests/compute/avail_nodebalancers.rb", "lib/fog/linode/requests/compute/avail_stackscripts.rb", "lib/fog/linode/requests/compute/image_delete.rb", "lib/fog/linode/requests/compute/image_list.rb", "lib/fog/linode/requests/compute/linode_boot.rb", "lib/fog/linode/requests/compute/linode_config_create.rb", "lib/fog/linode/requests/compute/linode_config_delete.rb", "lib/fog/linode/requests/compute/linode_config_list.rb", "lib/fog/linode/requests/compute/linode_config_update.rb", "lib/fog/linode/requests/compute/linode_create.rb", "lib/fog/linode/requests/compute/linode_delete.rb", "lib/fog/linode/requests/compute/linode_disk_create.rb", "lib/fog/linode/requests/compute/linode_disk_createfromdistribution.rb", "lib/fog/linode/requests/compute/linode_disk_createfromimage.rb", "lib/fog/linode/requests/compute/linode_disk_createfromstackscript.rb", "lib/fog/linode/requests/compute/linode_disk_delete.rb", "lib/fog/linode/requests/compute/linode_disk_duplicate.rb", "lib/fog/linode/requests/compute/linode_disk_imagize.rb", "lib/fog/linode/requests/compute/linode_disk_list.rb", "lib/fog/linode/requests/compute/linode_disk_resize.rb", "lib/fog/linode/requests/compute/linode_disk_update.rb", "lib/fog/linode/requests/compute/linode_ip_addprivate.rb", "lib/fog/linode/requests/compute/linode_ip_list.rb", "lib/fog/linode/requests/compute/linode_list.rb", "lib/fog/linode/requests/compute/linode_reboot.rb", "lib/fog/linode/requests/compute/linode_shutdown.rb", "lib/fog/linode/requests/compute/linode_update.rb", "lib/fog/linode/requests/compute/stackscript_list.rb", "lib/fog/linode/requests/dns/domain_create.rb", "lib/fog/linode/requests/dns/domain_delete.rb", "lib/fog/linode/requests/dns/domain_list.rb", "lib/fog/linode/requests/dns/domain_resource_create.rb", "lib/fog/linode/requests/dns/domain_resource_delete.rb", "lib/fog/linode/requests/dns/domain_resource_list.rb", "lib/fog/linode/requests/dns/domain_resource_update.rb", "lib/fog/linode/requests/dns/domain_update.rb", "lib/fog/ninefold.rb", "lib/fog/ninefold/compute.rb", "lib/fog/ninefold/core.rb", "lib/fog/ninefold/models/compute/address.rb", "lib/fog/ninefold/models/compute/addresses.rb", "lib/fog/ninefold/models/compute/flavor.rb", "lib/fog/ninefold/models/compute/flavors.rb", "lib/fog/ninefold/models/compute/image.rb", "lib/fog/ninefold/models/compute/images.rb", "lib/fog/ninefold/models/compute/ip_forwarding_rule.rb", "lib/fog/ninefold/models/compute/ip_forwarding_rules.rb", "lib/fog/ninefold/models/compute/server.rb", "lib/fog/ninefold/models/compute/servers.rb", "lib/fog/ninefold/requests/compute/assign_to_load_balancer_rule.rb", "lib/fog/ninefold/requests/compute/associate_ip_address.rb", "lib/fog/ninefold/requests/compute/change_service_for_virtual_machine.rb", "lib/fog/ninefold/requests/compute/create_ip_forwarding_rule.rb", "lib/fog/ninefold/requests/compute/create_load_balancer_rule.rb", "lib/fog/ninefold/requests/compute/delete_ip_forwarding_rule.rb", "lib/fog/ninefold/requests/compute/delete_load_balancer_rule.rb", "lib/fog/ninefold/requests/compute/deploy_virtual_machine.rb", "lib/fog/ninefold/requests/compute/destroy_virtual_machine.rb", "lib/fog/ninefold/requests/compute/disable_static_nat.rb", "lib/fog/ninefold/requests/compute/disassociate_ip_address.rb", "lib/fog/ninefold/requests/compute/enable_static_nat.rb", "lib/fog/ninefold/requests/compute/list_accounts.rb", "lib/fog/ninefold/requests/compute/list_async_jobs.rb", "lib/fog/ninefold/requests/compute/list_capabilities.rb", "lib/fog/ninefold/requests/compute/list_disk_offerings.rb", "lib/fog/ninefold/requests/compute/list_events.rb", "lib/fog/ninefold/requests/compute/list_hypervisors.rb", "lib/fog/ninefold/requests/compute/list_ip_forwarding_rules.rb", "lib/fog/ninefold/requests/compute/list_load_balancer_rule_instances.rb", "lib/fog/ninefold/requests/compute/list_load_balancer_rules.rb", "lib/fog/ninefold/requests/compute/list_network_offerings.rb", "lib/fog/ninefold/requests/compute/list_networks.rb", "lib/fog/ninefold/requests/compute/list_public_ip_addresses.rb", "lib/fog/ninefold/requests/compute/list_resource_limits.rb", "lib/fog/ninefold/requests/compute/list_service_offerings.rb", "lib/fog/ninefold/requests/compute/list_templates.rb", "lib/fog/ninefold/requests/compute/list_virtual_machines.rb", "lib/fog/ninefold/requests/compute/list_zones.rb", "lib/fog/ninefold/requests/compute/query_async_job_result.rb", "lib/fog/ninefold/requests/compute/reboot_virtual_machine.rb", "lib/fog/ninefold/requests/compute/remove_from_load_balancer_rule.rb", "lib/fog/ninefold/requests/compute/reset_password_for_virtual_machine.rb", "lib/fog/ninefold/requests/compute/start_virtual_machine.rb", "lib/fog/ninefold/requests/compute/stop_virtual_machine.rb", "lib/fog/ninefold/requests/compute/update_load_balancer_rule.rb", "lib/fog/ninefold/requests/compute/update_virtual_machine.rb", "lib/fog/ninefold/storage.rb", "lib/fog/opennebula.rb", "lib/fog/opennebula/README.md", "lib/fog/opennebula/compute.rb", "lib/fog/opennebula/core.rb", "lib/fog/opennebula/models/compute/flavor.rb", "lib/fog/opennebula/models/compute/flavors.rb", "lib/fog/opennebula/models/compute/group.rb", "lib/fog/opennebula/models/compute/groups.rb", "lib/fog/opennebula/models/compute/interface.rb", "lib/fog/opennebula/models/compute/interfaces.rb", "lib/fog/opennebula/models/compute/network.rb", "lib/fog/opennebula/models/compute/networks.rb", "lib/fog/opennebula/models/compute/server.rb", "lib/fog/opennebula/models/compute/servers.rb", "lib/fog/opennebula/requests/compute/OpenNebulaVNC.rb", "lib/fog/opennebula/requests/compute/get_vnc_console.rb", "lib/fog/opennebula/requests/compute/image_pool.rb", "lib/fog/opennebula/requests/compute/list_groups.rb", "lib/fog/opennebula/requests/compute/list_networks.rb", "lib/fog/opennebula/requests/compute/list_vms.rb", "lib/fog/opennebula/requests/compute/template_pool.rb", "lib/fog/opennebula/requests/compute/vm_allocate.rb", "lib/fog/opennebula/requests/compute/vm_destroy.rb", "lib/fog/opennebula/requests/compute/vm_disk_snapshot.rb", "lib/fog/opennebula/requests/compute/vm_resume.rb", "lib/fog/opennebula/requests/compute/vm_shutdown.rb", "lib/fog/opennebula/requests/compute/vm_stop.rb", "lib/fog/openvz.rb", "lib/fog/openvz/README.md", "lib/fog/openvz/compute.rb", "lib/fog/openvz/core.rb", "lib/fog/openvz/models/compute/server.rb", "lib/fog/openvz/models/compute/servers.rb", "lib/fog/openvz/requests/compute/compact_server.rb", "lib/fog/openvz/requests/compute/convert_server.rb", "lib/fog/openvz/requests/compute/create_server.rb", "lib/fog/openvz/requests/compute/destroy_server.rb", "lib/fog/openvz/requests/compute/exec2_server.rb", "lib/fog/openvz/requests/compute/exec_server.rb", "lib/fog/openvz/requests/compute/get_server_details.rb", "lib/fog/openvz/requests/compute/list_servers.rb", "lib/fog/openvz/requests/compute/mount_server.rb", "lib/fog/openvz/requests/compute/quotainit_server.rb", "lib/fog/openvz/requests/compute/quotaoff_server.rb", "lib/fog/openvz/requests/compute/quotaon_server.rb", "lib/fog/openvz/requests/compute/restart_server.rb", "lib/fog/openvz/requests/compute/resume_server.rb", "lib/fog/openvz/requests/compute/runscript_server.rb", "lib/fog/openvz/requests/compute/set_server.rb", "lib/fog/openvz/requests/compute/snapshot_delete_server.rb", "lib/fog/openvz/requests/compute/snapshot_list_server.rb", "lib/fog/openvz/requests/compute/snapshot_mount_server.rb", "lib/fog/openvz/requests/compute/snapshot_server.rb", "lib/fog/openvz/requests/compute/snapshot_switch_server.rb", "lib/fog/openvz/requests/compute/snapshot_umount_server.rb", "lib/fog/openvz/requests/compute/start_server.rb", "lib/fog/openvz/requests/compute/status_server.rb", "lib/fog/openvz/requests/compute/stop_server.rb", "lib/fog/openvz/requests/compute/suspend_server.rb", "lib/fog/openvz/requests/compute/umount_server.rb", "lib/fog/ovirt.rb", "lib/fog/ovirt/compute.rb", "lib/fog/ovirt/core.rb", "lib/fog/ovirt/models/compute/affinity_group.rb", "lib/fog/ovirt/models/compute/affinity_groups.rb", "lib/fog/ovirt/models/compute/cluster.rb", "lib/fog/ovirt/models/compute/clusters.rb", "lib/fog/ovirt/models/compute/interface.rb", "lib/fog/ovirt/models/compute/interfaces.rb", "lib/fog/ovirt/models/compute/quota.rb", "lib/fog/ovirt/models/compute/quotas.rb", "lib/fog/ovirt/models/compute/server.rb", "lib/fog/ovirt/models/compute/servers.rb", "lib/fog/ovirt/models/compute/template.rb", "lib/fog/ovirt/models/compute/templates.rb", "lib/fog/ovirt/models/compute/volume.rb", "lib/fog/ovirt/models/compute/volumes.rb", "lib/fog/ovirt/requests/compute/add_interface.rb", "lib/fog/ovirt/requests/compute/add_to_affinity_group.rb", "lib/fog/ovirt/requests/compute/add_volume.rb", "lib/fog/ovirt/requests/compute/attach_volume.rb", "lib/fog/ovirt/requests/compute/create_affinity_group.rb", "lib/fog/ovirt/requests/compute/create_vm.rb", "lib/fog/ovirt/requests/compute/datacenters.rb", "lib/fog/ovirt/requests/compute/destroy_affinity_group.rb", "lib/fog/ovirt/requests/compute/destroy_interface.rb", "lib/fog/ovirt/requests/compute/destroy_vm.rb", "lib/fog/ovirt/requests/compute/destroy_volume.rb", "lib/fog/ovirt/requests/compute/detach_volume.rb", "lib/fog/ovirt/requests/compute/get_affinity_group.rb", "lib/fog/ovirt/requests/compute/get_api_version.rb", "lib/fog/ovirt/requests/compute/get_cluster.rb", "lib/fog/ovirt/requests/compute/get_quota.rb", "lib/fog/ovirt/requests/compute/get_template.rb", "lib/fog/ovirt/requests/compute/get_virtual_machine.rb", "lib/fog/ovirt/requests/compute/list_affinity_group_vms.rb", "lib/fog/ovirt/requests/compute/list_affinity_groups.rb", "lib/fog/ovirt/requests/compute/list_clusters.rb", "lib/fog/ovirt/requests/compute/list_networks.rb", "lib/fog/ovirt/requests/compute/list_quotas.rb", "lib/fog/ovirt/requests/compute/list_template_interfaces.rb", "lib/fog/ovirt/requests/compute/list_template_volumes.rb", "lib/fog/ovirt/requests/compute/list_templates.rb", "lib/fog/ovirt/requests/compute/list_virtual_machines.rb", "lib/fog/ovirt/requests/compute/list_vm_interfaces.rb", "lib/fog/ovirt/requests/compute/list_vm_volumes.rb", "lib/fog/ovirt/requests/compute/list_volumes.rb", "lib/fog/ovirt/requests/compute/mock_files/affinitygroup.xml", "lib/fog/ovirt/requests/compute/mock_files/affinitygroup_vms.xml", "lib/fog/ovirt/requests/compute/mock_files/affinitygroups.xml", "lib/fog/ovirt/requests/compute/mock_files/cluster.xml", "lib/fog/ovirt/requests/compute/mock_files/clusters.xml", "lib/fog/ovirt/requests/compute/mock_files/data_centers.xml", "lib/fog/ovirt/requests/compute/mock_files/disks.xml", "lib/fog/ovirt/requests/compute/mock_files/nics.xml", "lib/fog/ovirt/requests/compute/mock_files/quotas.xml", "lib/fog/ovirt/requests/compute/mock_files/storage_domains.xml", "lib/fog/ovirt/requests/compute/mock_files/template.xml", "lib/fog/ovirt/requests/compute/mock_files/templates.xml", "lib/fog/ovirt/requests/compute/mock_files/vm.xml", "lib/fog/ovirt/requests/compute/mock_files/vms.xml", "lib/fog/ovirt/requests/compute/mock_files/volumes.xml", "lib/fog/ovirt/requests/compute/remove_from_affinity_group.rb", "lib/fog/ovirt/requests/compute/storage_domains.rb", "lib/fog/ovirt/requests/compute/update_interface.rb", "lib/fog/ovirt/requests/compute/update_vm.rb", "lib/fog/ovirt/requests/compute/update_volume.rb", "lib/fog/ovirt/requests/compute/vm_action.rb", "lib/fog/ovirt/requests/compute/vm_start_with_cloudinit.rb", "lib/fog/ovirt/requests/compute/vm_ticket.rb", "lib/fog/rage4.rb", "lib/fog/rage4/core.rb", "lib/fog/rage4/dns.rb", "lib/fog/rage4/models/dns/record.rb", "lib/fog/rage4/models/dns/records.rb", "lib/fog/rage4/models/dns/zone.rb", "lib/fog/rage4/models/dns/zones.rb", "lib/fog/rage4/requests/dns/create_domain.rb", "lib/fog/rage4/requests/dns/create_domain_vanity.rb", "lib/fog/rage4/requests/dns/create_record.rb", "lib/fog/rage4/requests/dns/create_reverse_domain_4.rb", "lib/fog/rage4/requests/dns/delete_domain.rb", "lib/fog/rage4/requests/dns/delete_record.rb", "lib/fog/rage4/requests/dns/get_domain.rb", "lib/fog/rage4/requests/dns/get_domain_by_name.rb", "lib/fog/rage4/requests/dns/list_domains.rb", "lib/fog/rage4/requests/dns/list_geo_regions.rb", "lib/fog/rage4/requests/dns/list_record_types.rb", "lib/fog/rage4/requests/dns/list_records.rb", "lib/fog/rage4/requests/dns/set_record_failover.rb", "lib/fog/rage4/requests/dns/show_current_usage.rb", "lib/fog/rage4/requests/dns/show_global_usage.rb", "lib/fog/rage4/requests/dns/update_domain.rb", "lib/fog/rage4/requests/dns/update_record.rb", "lib/fog/vcloud.rb", "lib/fog/vcloud/compute.rb", "lib/fog/vcloud/core.rb", "lib/fog/vcloud/examples/README.md", "lib/fog/vcloud/examples/creating_a_connection.md", "lib/fog/vcloud/examples/creating_a_vapp.md", "lib/fog/vcloud/examples/get_network_information.md", "lib/fog/vcloud/examples/get_vapp_information.md", "lib/fog/vcloud/examples/more_on_vapps.md", "lib/fog/vcloud/models/compute/catalog.rb", "lib/fog/vcloud/models/compute/catalog_item.rb", "lib/fog/vcloud/models/compute/catalog_items.rb", "lib/fog/vcloud/models/compute/catalogs.rb", "lib/fog/vcloud/models/compute/helpers/status.rb", "lib/fog/vcloud/models/compute/ip.rb", "lib/fog/vcloud/models/compute/ips.rb", "lib/fog/vcloud/models/compute/network.rb", "lib/fog/vcloud/models/compute/networks.rb", "lib/fog/vcloud/models/compute/organization.rb", "lib/fog/vcloud/models/compute/organizations.rb", "lib/fog/vcloud/models/compute/server.rb", "lib/fog/vcloud/models/compute/servers.rb", "lib/fog/vcloud/models/compute/tag.rb", "lib/fog/vcloud/models/compute/tags.rb", "lib/fog/vcloud/models/compute/task.rb", "lib/fog/vcloud/models/compute/tasks.rb", "lib/fog/vcloud/models/compute/vapp.rb", "lib/fog/vcloud/models/compute/vapps.rb", "lib/fog/vcloud/models/compute/vdc.rb", "lib/fog/vcloud/models/compute/vdcs.rb", "lib/fog/vcloud/requests/compute/clone_vapp.rb", "lib/fog/vcloud/requests/compute/configure_metadata.rb", "lib/fog/vcloud/requests/compute/configure_network.rb", "lib/fog/vcloud/requests/compute/configure_network_ip.rb", "lib/fog/vcloud/requests/compute/configure_node.rb", "lib/fog/vcloud/requests/compute/configure_org_network.rb", "lib/fog/vcloud/requests/compute/configure_vapp.rb", "lib/fog/vcloud/requests/compute/configure_vm.rb", "lib/fog/vcloud/requests/compute/configure_vm_cpus.rb", "lib/fog/vcloud/requests/compute/configure_vm_customization_script.rb", "lib/fog/vcloud/requests/compute/configure_vm_disks.rb", "lib/fog/vcloud/requests/compute/configure_vm_memory.rb", "lib/fog/vcloud/requests/compute/configure_vm_name_description.rb", "lib/fog/vcloud/requests/compute/configure_vm_network.rb", "lib/fog/vcloud/requests/compute/configure_vm_password.rb", "lib/fog/vcloud/requests/compute/delete_metadata.rb", "lib/fog/vcloud/requests/compute/delete_node.rb", "lib/fog/vcloud/requests/compute/delete_vapp.rb", "lib/fog/vcloud/requests/compute/get_catalog.rb", "lib/fog/vcloud/requests/compute/get_catalog_item.rb", "lib/fog/vcloud/requests/compute/get_customization_options.rb", "lib/fog/vcloud/requests/compute/get_metadata.rb", "lib/fog/vcloud/requests/compute/get_network.rb", "lib/fog/vcloud/requests/compute/get_network_extensions.rb", "lib/fog/vcloud/requests/compute/get_network_ip.rb", "lib/fog/vcloud/requests/compute/get_network_ips.rb", "lib/fog/vcloud/requests/compute/get_organization.rb", "lib/fog/vcloud/requests/compute/get_server.rb", "lib/fog/vcloud/requests/compute/get_task.rb", "lib/fog/vcloud/requests/compute/get_task_list.rb", "lib/fog/vcloud/requests/compute/get_vapp.rb", "lib/fog/vcloud/requests/compute/get_vapp_template.rb", "lib/fog/vcloud/requests/compute/get_vdc.rb", "lib/fog/vcloud/requests/compute/get_vm_disks.rb", "lib/fog/vcloud/requests/compute/get_vm_memory.rb", "lib/fog/vcloud/requests/compute/instantiate_vapp_template.rb", "lib/fog/vcloud/requests/compute/login.rb", "lib/fog/vcloud/requests/compute/power_off.rb", "lib/fog/vcloud/requests/compute/power_on.rb", "lib/fog/vcloud/requests/compute/power_reset.rb", "lib/fog/vcloud/requests/compute/power_shutdown.rb", "lib/fog/vcloud/requests/compute/undeploy.rb", "lib/fog/vcloud_director.rb", "lib/fog/vcloud_director/README.md", "lib/fog/vcloud_director/compute.rb", "lib/fog/vcloud_director/core.rb", "lib/fog/vcloud_director/generators/compute/compose_common.rb", "lib/fog/vcloud_director/generators/compute/compose_vapp.rb", "lib/fog/vcloud_director/generators/compute/customization.rb", "lib/fog/vcloud_director/generators/compute/disks.rb", "lib/fog/vcloud_director/generators/compute/edge_gateway_service_configuration.rb", "lib/fog/vcloud_director/generators/compute/instantiate_vapp_template_params.rb", "lib/fog/vcloud_director/generators/compute/metadata.rb", "lib/fog/vcloud_director/generators/compute/org_vdc_network.rb", "lib/fog/vcloud_director/generators/compute/recompose_vapp.rb", "lib/fog/vcloud_director/generators/compute/vapp.rb", "lib/fog/vcloud_director/generators/compute/vm.rb", "lib/fog/vcloud_director/generators/compute/vm_network.rb", "lib/fog/vcloud_director/models/compute/catalog.rb", "lib/fog/vcloud_director/models/compute/catalog_item.rb", "lib/fog/vcloud_director/models/compute/catalog_items.rb", "lib/fog/vcloud_director/models/compute/catalogs.rb", "lib/fog/vcloud_director/models/compute/custom_field.rb", "lib/fog/vcloud_director/models/compute/custom_fields.rb", "lib/fog/vcloud_director/models/compute/disk.rb", "lib/fog/vcloud_director/models/compute/disks.rb", "lib/fog/vcloud_director/models/compute/media.rb", "lib/fog/vcloud_director/models/compute/medias.rb", "lib/fog/vcloud_director/models/compute/network.rb", "lib/fog/vcloud_director/models/compute/networks.rb", "lib/fog/vcloud_director/models/compute/organization.rb", "lib/fog/vcloud_director/models/compute/organizations.rb", "lib/fog/vcloud_director/models/compute/tag.rb", "lib/fog/vcloud_director/models/compute/tags.rb", "lib/fog/vcloud_director/models/compute/task.rb", "lib/fog/vcloud_director/models/compute/tasks.rb", "lib/fog/vcloud_director/models/compute/template_vm.rb", "lib/fog/vcloud_director/models/compute/template_vms.rb", "lib/fog/vcloud_director/models/compute/vapp.rb", "lib/fog/vcloud_director/models/compute/vapp_template.rb", "lib/fog/vcloud_director/models/compute/vapp_templates.rb", "lib/fog/vcloud_director/models/compute/vapps.rb", "lib/fog/vcloud_director/models/compute/vdc.rb", "lib/fog/vcloud_director/models/compute/vdcs.rb", "lib/fog/vcloud_director/models/compute/vm.rb", "lib/fog/vcloud_director/models/compute/vm_customization.rb", "lib/fog/vcloud_director/models/compute/vm_customizations.rb", "lib/fog/vcloud_director/models/compute/vm_network.rb", "lib/fog/vcloud_director/models/compute/vm_networks.rb", "lib/fog/vcloud_director/models/compute/vms.rb", "lib/fog/vcloud_director/parsers/compute/disks.rb", "lib/fog/vcloud_director/parsers/compute/metadata.rb", "lib/fog/vcloud_director/parsers/compute/network.rb", "lib/fog/vcloud_director/parsers/compute/vm.rb", "lib/fog/vcloud_director/parsers/compute/vm_customization.rb", "lib/fog/vcloud_director/parsers/compute/vm_network.rb", "lib/fog/vcloud_director/parsers/compute/vm_parser_helper.rb", "lib/fog/vcloud_director/parsers/compute/vms.rb", "lib/fog/vcloud_director/parsers/compute/vms_by_metadata.rb", "lib/fog/vcloud_director/query.rb", "lib/fog/vcloud_director/requests/compute/delete_catalog_item.rb", "lib/fog/vcloud_director/requests/compute/delete_catalog_item_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/delete_disk.rb", "lib/fog/vcloud_director/requests/compute/delete_disk_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/delete_logout.rb", "lib/fog/vcloud_director/requests/compute/delete_media.rb", "lib/fog/vcloud_director/requests/compute/delete_media_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/delete_network.rb", "lib/fog/vcloud_director/requests/compute/delete_shadow_vm.rb", "lib/fog/vcloud_director/requests/compute/delete_vapp.rb", "lib/fog/vcloud_director/requests/compute/delete_vapp_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/delete_vapp_template.rb", "lib/fog/vcloud_director/requests/compute/delete_vapp_template_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_allocated_ip_addresses.rb", "lib/fog/vcloud_director/requests/compute/get_catalog.rb", "lib/fog/vcloud_director/requests/compute/get_catalog_item.rb", "lib/fog/vcloud_director/requests/compute/get_catalog_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_catalog_item_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_catalog_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_catalog_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_catalogs_from_query.rb", "lib/fog/vcloud_director/requests/compute/get_control_access_params_catalog.rb", "lib/fog/vcloud_director/requests/compute/get_control_access_params_vapp.rb", "lib/fog/vcloud_director/requests/compute/get_cpu_rasd_item.rb", "lib/fog/vcloud_director/requests/compute/get_current_session.rb", "lib/fog/vcloud_director/requests/compute/get_disk.rb", "lib/fog/vcloud_director/requests/compute/get_disk_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_disk_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_disk_owner.rb", "lib/fog/vcloud_director/requests/compute/get_disks_from_query.rb", "lib/fog/vcloud_director/requests/compute/get_disks_rasd_items_list.rb", "lib/fog/vcloud_director/requests/compute/get_edge_gateway.rb", "lib/fog/vcloud_director/requests/compute/get_entity.rb", "lib/fog/vcloud_director/requests/compute/get_execute_query.rb", "lib/fog/vcloud_director/requests/compute/get_groups_from_query.rb", "lib/fog/vcloud_director/requests/compute/get_guest_customization_system_section_vapp.rb", "lib/fog/vcloud_director/requests/compute/get_guest_customization_system_section_vapp_template.rb", "lib/fog/vcloud_director/requests/compute/get_href.rb", "lib/fog/vcloud_director/requests/compute/get_lease_settings_section_vapp.rb", "lib/fog/vcloud_director/requests/compute/get_lease_settings_section_vapp_template.rb", "lib/fog/vcloud_director/requests/compute/get_media.rb", "lib/fog/vcloud_director/requests/compute/get_media_drives_rasd_items_list.rb", "lib/fog/vcloud_director/requests/compute/get_media_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_media_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_media_owner.rb", "lib/fog/vcloud_director/requests/compute/get_medias_from_query.rb", "lib/fog/vcloud_director/requests/compute/get_memory_rasd_item.rb", "lib/fog/vcloud_director/requests/compute/get_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_network.rb", "lib/fog/vcloud_director/requests/compute/get_network_cards_items_list.rb", "lib/fog/vcloud_director/requests/compute/get_network_complete.rb", "lib/fog/vcloud_director/requests/compute/get_network_config_section_vapp.rb", "lib/fog/vcloud_director/requests/compute/get_network_config_section_vapp_template.rb", "lib/fog/vcloud_director/requests/compute/get_network_connection_system_section_vapp.rb", "lib/fog/vcloud_director/requests/compute/get_network_connection_system_section_vapp_template.rb", "lib/fog/vcloud_director/requests/compute/get_network_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_network_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_network_section_vapp.rb", "lib/fog/vcloud_director/requests/compute/get_network_section_vapp_template.rb", "lib/fog/vcloud_director/requests/compute/get_operating_system_section.rb", "lib/fog/vcloud_director/requests/compute/get_org_settings.rb", "lib/fog/vcloud_director/requests/compute/get_org_vdc_gateways.rb", "lib/fog/vcloud_director/requests/compute/get_organization.rb", "lib/fog/vcloud_director/requests/compute/get_organization_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_organization_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_organizations.rb", "lib/fog/vcloud_director/requests/compute/get_organizations_from_query.rb", "lib/fog/vcloud_director/requests/compute/get_product_sections_vapp.rb", "lib/fog/vcloud_director/requests/compute/get_product_sections_vapp_template.rb", "lib/fog/vcloud_director/requests/compute/get_request.rb", "lib/fog/vcloud_director/requests/compute/get_runtime_info_section_type.rb", "lib/fog/vcloud_director/requests/compute/get_serial_ports_items_list.rb", "lib/fog/vcloud_director/requests/compute/get_shadow_vm.rb", "lib/fog/vcloud_director/requests/compute/get_snapshot_section.rb", "lib/fog/vcloud_director/requests/compute/get_startup_section.rb", "lib/fog/vcloud_director/requests/compute/get_supported_systems_info.rb", "lib/fog/vcloud_director/requests/compute/get_supported_versions.rb", "lib/fog/vcloud_director/requests/compute/get_task.rb", "lib/fog/vcloud_director/requests/compute/get_task_list.rb", "lib/fog/vcloud_director/requests/compute/get_template_vm.rb", "lib/fog/vcloud_director/requests/compute/get_template_vms.rb", "lib/fog/vcloud_director/requests/compute/get_thumbnail.rb", "lib/fog/vcloud_director/requests/compute/get_users_from_query.rb", "lib/fog/vcloud_director/requests/compute/get_vapp.rb", "lib/fog/vcloud_director/requests/compute/get_vapp_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_vapp_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_vapp_ovf_descriptor.rb", "lib/fog/vcloud_director/requests/compute/get_vapp_owner.rb", "lib/fog/vcloud_director/requests/compute/get_vapp_template.rb", "lib/fog/vcloud_director/requests/compute/get_vapp_template_customization_system_section.rb", "lib/fog/vcloud_director/requests/compute/get_vapp_template_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_vapp_template_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_vapp_template_ovf_descriptor.rb", "lib/fog/vcloud_director/requests/compute/get_vapp_template_owner.rb", "lib/fog/vcloud_director/requests/compute/get_vapp_templates_from_query.rb", "lib/fog/vcloud_director/requests/compute/get_vapps_in_lease_from_query.rb", "lib/fog/vcloud_director/requests/compute/get_vcloud.rb", "lib/fog/vcloud_director/requests/compute/get_vdc.rb", "lib/fog/vcloud_director/requests/compute/get_vdc_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_vdc_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_vdc_storage_class.rb", "lib/fog/vcloud_director/requests/compute/get_vdc_storage_class_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_vdc_storage_class_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_vdcs_from_query.rb", "lib/fog/vcloud_director/requests/compute/get_virtual_hardware_section.rb", "lib/fog/vcloud_director/requests/compute/get_vm.rb", "lib/fog/vcloud_director/requests/compute/get_vm_capabilities.rb", "lib/fog/vcloud_director/requests/compute/get_vm_compliance_results.rb", "lib/fog/vcloud_director/requests/compute/get_vm_customization.rb", "lib/fog/vcloud_director/requests/compute/get_vm_disks.rb", "lib/fog/vcloud_director/requests/compute/get_vm_network.rb", "lib/fog/vcloud_director/requests/compute/get_vm_pending_question.rb", "lib/fog/vcloud_director/requests/compute/get_vms.rb", "lib/fog/vcloud_director/requests/compute/get_vms_by_metadata.rb", "lib/fog/vcloud_director/requests/compute/get_vms_disk_attached_to.rb", "lib/fog/vcloud_director/requests/compute/get_vms_in_lease_from_query.rb", "lib/fog/vcloud_director/requests/compute/instantiate_vapp_template.rb", "lib/fog/vcloud_director/requests/compute/post_acquire_ticket.rb", "lib/fog/vcloud_director/requests/compute/post_answer_vm_pending_question.rb", "lib/fog/vcloud_director/requests/compute/post_attach_disk.rb", "lib/fog/vcloud_director/requests/compute/post_cancel_task.rb", "lib/fog/vcloud_director/requests/compute/post_capture_vapp.rb", "lib/fog/vcloud_director/requests/compute/post_check_vm_compliance.rb", "lib/fog/vcloud_director/requests/compute/post_clone_media.rb", "lib/fog/vcloud_director/requests/compute/post_clone_vapp.rb", "lib/fog/vcloud_director/requests/compute/post_clone_vapp_template.rb", "lib/fog/vcloud_director/requests/compute/post_compose_vapp.rb", "lib/fog/vcloud_director/requests/compute/post_configure_edge_gateway_services.rb", "lib/fog/vcloud_director/requests/compute/post_consolidate_vm_vapp.rb", "lib/fog/vcloud_director/requests/compute/post_consolidate_vm_vapp_template.rb", "lib/fog/vcloud_director/requests/compute/post_create_catalog_item.rb", "lib/fog/vcloud_director/requests/compute/post_create_org_vdc_network.rb", "lib/fog/vcloud_director/requests/compute/post_deploy_vapp.rb", "lib/fog/vcloud_director/requests/compute/post_detach_disk.rb", "lib/fog/vcloud_director/requests/compute/post_disable_nested_hv.rb", "lib/fog/vcloud_director/requests/compute/post_disable_vapp_template_download.rb", "lib/fog/vcloud_director/requests/compute/post_discard_vapp_state.rb", "lib/fog/vcloud_director/requests/compute/post_eject_cd_rom.rb", "lib/fog/vcloud_director/requests/compute/post_enable_nested_hv.rb", "lib/fog/vcloud_director/requests/compute/post_enable_vapp_template_download.rb", "lib/fog/vcloud_director/requests/compute/post_enter_maintenance_mode.rb", "lib/fog/vcloud_director/requests/compute/post_exit_maintenance_mode.rb", "lib/fog/vcloud_director/requests/compute/post_insert_cd_rom.rb", "lib/fog/vcloud_director/requests/compute/post_install_vmware_tools.rb", "lib/fog/vcloud_director/requests/compute/post_instantiate_vapp_template.rb", "lib/fog/vcloud_director/requests/compute/post_login_session.rb", "lib/fog/vcloud_director/requests/compute/post_power_off_vapp.rb", "lib/fog/vcloud_director/requests/compute/post_power_on_vapp.rb", "lib/fog/vcloud_director/requests/compute/post_reboot_vapp.rb", "lib/fog/vcloud_director/requests/compute/post_recompose_vapp.rb", "lib/fog/vcloud_director/requests/compute/post_reconfigure_vm.rb", "lib/fog/vcloud_director/requests/compute/post_remove_all_snapshots.rb", "lib/fog/vcloud_director/requests/compute/post_reset_vapp.rb", "lib/fog/vcloud_director/requests/compute/post_revert_snapshot.rb", "lib/fog/vcloud_director/requests/compute/post_shutdown_vapp.rb", "lib/fog/vcloud_director/requests/compute/post_suspend_vapp.rb", "lib/fog/vcloud_director/requests/compute/post_undeploy_vapp.rb", "lib/fog/vcloud_director/requests/compute/post_update_catalog_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/post_update_disk_metadata.rb", "lib/fog/vcloud_director/requests/compute/post_update_media_metadata.rb", "lib/fog/vcloud_director/requests/compute/post_update_vapp_metadata.rb", "lib/fog/vcloud_director/requests/compute/post_update_vapp_template_metadata.rb", "lib/fog/vcloud_director/requests/compute/post_upgrade_hw_version.rb", "lib/fog/vcloud_director/requests/compute/post_upload_disk.rb", "lib/fog/vcloud_director/requests/compute/post_upload_media.rb", "lib/fog/vcloud_director/requests/compute/post_upload_vapp_template.rb", "lib/fog/vcloud_director/requests/compute/put_catalog_item_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/put_cpu.rb", "lib/fog/vcloud_director/requests/compute/put_disk_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/put_disks.rb", "lib/fog/vcloud_director/requests/compute/put_guest_customization_section_vapp.rb", "lib/fog/vcloud_director/requests/compute/put_media_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/put_memory.rb", "lib/fog/vcloud_director/requests/compute/put_metadata_value.rb", "lib/fog/vcloud_director/requests/compute/put_network.rb", "lib/fog/vcloud_director/requests/compute/put_network_connection_system_section_vapp.rb", "lib/fog/vcloud_director/requests/compute/put_product_sections.rb", "lib/fog/vcloud_director/requests/compute/put_vapp_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/put_vapp_name_and_description.rb", "lib/fog/vcloud_director/requests/compute/put_vapp_template_metadata_item_metadata.rb", "lib/fog/vcloud_director/requests/compute/put_vm.rb", "lib/fog/vcloud_director/requests/compute/put_vm_capabilities.rb", "lib/fog/version.rb", "lib/fog/zerigo.rb", "lib/fog/zerigo/core.rb", "lib/fog/zerigo/dns.rb", "lib/fog/zerigo/models/dns/record.rb", "lib/fog/zerigo/models/dns/records.rb", "lib/fog/zerigo/models/dns/zone.rb", "lib/fog/zerigo/models/dns/zones.rb", "lib/fog/zerigo/parsers/dns/count_hosts.rb", "lib/fog/zerigo/parsers/dns/count_zones.rb", "lib/fog/zerigo/parsers/dns/create_host.rb", "lib/fog/zerigo/parsers/dns/create_zone.rb", "lib/fog/zerigo/parsers/dns/find_hosts.rb", "lib/fog/zerigo/parsers/dns/get_host.rb", "lib/fog/zerigo/parsers/dns/get_zone.rb", "lib/fog/zerigo/parsers/dns/get_zone_stats.rb", "lib/fog/zerigo/parsers/dns/list_hosts.rb", "lib/fog/zerigo/parsers/dns/list_zones.rb", "lib/fog/zerigo/requests/dns/count_hosts.rb", "lib/fog/zerigo/requests/dns/count_zones.rb", "lib/fog/zerigo/requests/dns/create_host.rb", "lib/fog/zerigo/requests/dns/create_zone.rb", "lib/fog/zerigo/requests/dns/delete_host.rb", "lib/fog/zerigo/requests/dns/delete_zone.rb", "lib/fog/zerigo/requests/dns/find_hosts.rb", "lib/fog/zerigo/requests/dns/get_host.rb", "lib/fog/zerigo/requests/dns/get_zone.rb", "lib/fog/zerigo/requests/dns/get_zone_stats.rb", "lib/fog/zerigo/requests/dns/list_hosts.rb", "lib/fog/zerigo/requests/dns/list_zones.rb", "lib/fog/zerigo/requests/dns/update_host.rb", "lib/fog/zerigo/requests/dns/update_zone.rb", "lib/tasks/changelog_task.rb", "lib/tasks/github_release_task.rb", "spec/fog/account_spec.rb", "spec/fog/billing_spec.rb", "spec/fog/bin/atmos_spec.rb", "spec/fog/bin/aws_spec.rb", "spec/fog/bin/baremetalcloud_spec.rb", "spec/fog/bin/bluebox_spec.rb", "spec/fog/bin/brightbox_spec.rb", "spec/fog/bin/clodo_spec.rb", "spec/fog/bin/cloudsigma_spec.rb", "spec/fog/bin/cloudstack_spec.rb", "spec/fog/bin/digitalocean_spec.rb", "spec/fog/bin/dnsimple_spec.rb", "spec/fog/bin/dnsmadeeasy_spec.rb", "spec/fog/bin/dreamhost_spec.rb", "spec/fog/bin/dynect_spec.rb", "spec/fog/bin/ecloud_spec.rb", "spec/fog/bin/fogdocker_spec.rb", "spec/fog/bin/glesys_spec.rb", "spec/fog/bin/gogrid_spec.rb", "spec/fog/bin/google_spec.rb", "spec/fog/bin/ibm_spec.rb", "spec/fog/bin/internetarchive_spec.rb", "spec/fog/bin/joyent_spec.rb", "spec/fog/bin/linode_spec.rb", "spec/fog/bin/local_spec.rb", "spec/fog/bin/ninefold_spec.rb", "spec/fog/bin/opennebula_spec.rb", "spec/fog/bin/openstack_spec.rb", "spec/fog/bin/openvz_spec.rb", "spec/fog/bin/ovirt_spec.rb", "spec/fog/bin/powerdns_spec.rb", "spec/fog/bin/profitbricks_spec.rb", "spec/fog/bin/rackspace_spec.rb", "spec/fog/bin/rage4_spec.rb", "spec/fog/bin/riakcs_spec.rb", "spec/fog/bin/sakuracloud_spec.rb", "spec/fog/bin/serverlove_spec.rb", "spec/fog/bin/softlayer_spec.rb", "spec/fog/bin/stormondemand_spec.rb", "spec/fog/bin/vcloud_spec.rb", "spec/fog/bin/vclouddirector_spec.rb", "spec/fog/bin/vmfusion_spec.rb", "spec/fog/bin/voxel_spec.rb", "spec/fog/bin/vsphere_spec.rb", "spec/fog/bin/xenserver_spec.rb", "spec/fog/bin/zerigo_spec.rb", "spec/fog/bin_spec.rb", "spec/fog/cdn_spec.rb", "spec/fog/compute_spec.rb", "spec/fog/dns_spec.rb", "spec/fog/identity_spec.rb", "spec/fog/image_spec.rb", "spec/fog/metering_spec.rb", "spec/fog/monitoring_spec.rb", "spec/fog/network_spec.rb", "spec/fog/orchestration_spec.rb", "spec/fog/storage_spec.rb", "spec/fog/support_spec.rb", "spec/fog/volume_spec.rb", "spec/fog/vpn_spec.rb", "spec/fog/xml/connection_spec.rb", "spec/helpers/bin.rb", "spec/spec_helper.rb", "spec/vcloud_director/generators/compute/instantiate_vapp_template_params_spec.rb", "spec/vcloud_director/requests/compute/instantiate_vapp_template_spec.rb", "spec/vcloud_director/spec_helper.rb", "tests/bluebox/requests/blb/helper.rb", "tests/bluebox/requests/blb/lb_tests.rb", "tests/bluebox/requests/compute/block_tests.rb", "tests/bluebox/requests/compute/helper.rb", "tests/bluebox/requests/compute/location_tests.rb", "tests/bluebox/requests/compute/product_tests.rb", "tests/bluebox/requests/compute/template_tests.rb", "tests/bluebox/requests/dns/dns_tests.rb", "tests/clodo/requests/compute/image_tests.rb", "tests/clodo/requests/compute/server_tests.rb", "tests/cloudsigma/models/server_tests.rb", "tests/cloudsigma/models/servers_tests.rb", "tests/cloudsigma/models/volume_tests.rb", "tests/cloudsigma/models/volumes_tests.rb", "tests/cloudsigma/requests/server_tests.rb", "tests/cloudsigma/requests/volumes_tests.rb", "tests/cloudstack/compute/models/disk_offering_tests.rb", "tests/cloudstack/compute/models/egress_firewall_rule_tests.rb", "tests/cloudstack/compute/models/public_ip_address_tests.rb", "tests/cloudstack/compute/models/public_ip_addresses_tests.rb", "tests/cloudstack/compute/models/security_group_rule_tests.rb", "tests/cloudstack/compute/models/security_group_tests.rb", "tests/cloudstack/compute/models/security_groups_tests.rb", "tests/cloudstack/compute/models/server_tests.rb", "tests/cloudstack/compute/models/snapshot_tests.rb", "tests/cloudstack/compute/models/volume_tests.rb", "tests/cloudstack/compute/models/volumes_tests.rb", "tests/cloudstack/requests/disk_offering_tests.rb", "tests/cloudstack/requests/egress_firewall_rule_tests.rb", "tests/cloudstack/requests/firewall_rule_tests.rb", "tests/cloudstack/requests/network_offering_tests.rb", "tests/cloudstack/requests/os_type_tests.rb", "tests/cloudstack/requests/port_forwarding_rule_tests.rb", "tests/cloudstack/requests/public_ip_address_tests.rb", "tests/cloudstack/requests/security_group_tests.rb", "tests/cloudstack/requests/service_offering_tests.rb", "tests/cloudstack/requests/snapshot_tests.rb", "tests/cloudstack/requests/ssh_key_pair_tests.rb", "tests/cloudstack/requests/template_tests.rb", "tests/cloudstack/requests/virtual_machine_tests.rb", "tests/cloudstack/requests/volume_tests.rb", "tests/cloudstack/requests/zone_tests.rb", "tests/cloudstack/signed_params_tests.rb", "tests/compute/helper.rb", "tests/compute/models/flavors_tests.rb", "tests/compute/models/server_tests.rb", "tests/compute/models/servers_tests.rb", "tests/core/attribute_tests.rb", "tests/core/credential_tests.rb", "tests/core/current_machine_tests.rb", "tests/core/mocking_tests.rb", "tests/core/parser_tests.rb", "tests/core/service_tests.rb", "tests/core/timeout_tests.rb", "tests/core/uuid_tests.rb", "tests/core/wait_for_tests.rb", "tests/digitalocean/helper.rb", "tests/digitalocean/requests/compute_v2/list_flavors_tests.rb", "tests/digitalocean/requests/compute_v2/list_images_tests.rb", "tests/digitalocean/requests/compute_v2/list_regions_tests.rb", "tests/digitalocean/requests/compute_v2/server_tests.rb", "tests/dns/helper.rb", "tests/dns/models/record_tests.rb", "tests/dns/models/records_tests.rb", "tests/dns/models/zone_tests.rb", "tests/dns/models/zones_tests.rb", "tests/dnsimple/requests/dns/dns_tests.rb", "tests/dnsmadeeasy/requests/dns/dns_tests.rb", "tests/dreamhost/README.md", "tests/dreamhost/dns_tests.rb", "tests/dreamhost/helper.rb", "tests/dreamhost/models/dns/record_tests.rb", "tests/dreamhost/models/dns/records_tests.rb", "tests/dreamhost/models/dns/zone_tests.rb", "tests/dreamhost/models/dns/zones_tests.rb", "tests/dreamhost/requests/dns/create_record_tests.rb", "tests/dreamhost/requests/dns/delete_record_tests.rb", "tests/dreamhost/requests/dns/list_records_tests.rb", "tests/fogdocker/compute_tests.rb", "tests/fogdocker/models/compute/image_tests.rb", "tests/fogdocker/models/compute/images_tests.rb", "tests/fogdocker/models/compute/server_tests.rb", "tests/fogdocker/models/compute/servers_tests.rb", "tests/fogdocker/requests/compute/api_version_tests.rb", "tests/fogdocker/requests/compute/container_action_tests.rb", "tests/fogdocker/requests/compute/container_commit_tests.rb", "tests/fogdocker/requests/compute/container_create_tests.rb", "tests/fogdocker/requests/compute/container_delete_tests.rb", "tests/fogdocker/requests/compute/image_create_tests.rb", "tests/fogdocker/requests/compute/image_delete_tests.rb", "tests/fogdocker/requests/compute/image_search_tests.rb", "tests/glesys/requests/compute/helper.rb", "tests/glesys/requests/compute/ip_tests.rb", "tests/glesys/requests/compute/server_tests.rb", "tests/glesys/requests/compute/ssh_key_tests.rb", "tests/glesys/requests/compute/template_tests.rb", "tests/go_grid/requests/compute/image_tests.rb", "tests/helper.rb", "tests/helpers/collection_helper.rb", "tests/helpers/compute/flavors_helper.rb", "tests/helpers/compute/server_helper.rb", "tests/helpers/compute/servers_helper.rb", "tests/helpers/formats_helper.rb", "tests/helpers/formats_helper_tests.rb", "tests/helpers/mock_helper.rb", "tests/helpers/model_helper.rb", "tests/helpers/responds_to_helper.rb", "tests/helpers/schema_validator_tests.rb", "tests/helpers/succeeds_helper.rb", "tests/hp/block_storage_tests.rb", "tests/hp/cdn_tests.rb", "tests/hp/compute_tests.rb", "tests/hp/models/block_storage/bootable_volume_tests.rb", "tests/hp/models/block_storage/snapshot_tests.rb", "tests/hp/models/block_storage/volume_tests.rb", "tests/hp/models/block_storage_v2/snapshot_tests.rb", "tests/hp/models/block_storage_v2/snapshots_tests.rb", "tests/hp/models/block_storage_v2/volume_backup_tests.rb", "tests/hp/models/block_storage_v2/volume_backups_tests.rb", "tests/hp/models/block_storage_v2/volume_tests.rb", "tests/hp/models/block_storage_v2/volumes_tests.rb", "tests/hp/models/compute/address_tests.rb", "tests/hp/models/compute/addresses_tests.rb", "tests/hp/models/compute/key_pair_tests.rb", "tests/hp/models/compute/key_pairs_tests.rb", "tests/hp/models/compute/metadata_image_tests.rb", "tests/hp/models/compute/metadata_server_tests.rb", "tests/hp/models/compute/security_group_tests.rb", "tests/hp/models/compute/security_groups_tests.rb", "tests/hp/models/compute_v2/address_tests.rb", "tests/hp/models/compute_v2/addresses_tests.rb", "tests/hp/models/compute_v2/availability_zone_tests.rb", "tests/hp/models/compute_v2/availability_zones_tests.rb", "tests/hp/models/compute_v2/key_pair_tests.rb", "tests/hp/models/compute_v2/key_pairs_tests.rb", "tests/hp/models/compute_v2/metadata_image_tests.rb", "tests/hp/models/compute_v2/metadata_server_tests.rb", "tests/hp/models/compute_v2/server_tests.rb", "tests/hp/models/compute_v2/servers_tests.rb", "tests/hp/models/compute_v2/volume_attachment_tests.rb", "tests/hp/models/compute_v2/volume_attachments_tests.rb", "tests/hp/models/dns/domain_tests.rb", "tests/hp/models/dns/domains_tests.rb", "tests/hp/models/dns/record_tests.rb", "tests/hp/models/dns/records_tests.rb", "tests/hp/models/lb/algorithms_tests.rb", "tests/hp/models/lb/load_balancer_node_tests.rb", "tests/hp/models/lb/load_balancer_nodes_tests.rb", "tests/hp/models/lb/load_balancer_tests.rb", "tests/hp/models/lb/load_balancer_virtual_ips_tests.rb", "tests/hp/models/lb/load_balancers_tests.rb", "tests/hp/models/lb/protocols_tests.rb", "tests/hp/models/network/floating_ip_tests.rb", "tests/hp/models/network/floating_ips_tests.rb", "tests/hp/models/network/network_tests.rb", "tests/hp/models/network/networks_tests.rb", "tests/hp/models/network/port_tests.rb", "tests/hp/models/network/ports_tests.rb", "tests/hp/models/network/router_tests.rb", "tests/hp/models/network/routers_tests.rb", "tests/hp/models/network/security_group_rule_tests.rb", "tests/hp/models/network/security_group_rules_tests.rb", "tests/hp/models/network/security_group_tests.rb", "tests/hp/models/network/security_groups_tests.rb", "tests/hp/models/network/subnet_tests.rb", "tests/hp/models/network/subnets_tests.rb", "tests/hp/models/storage/directories_tests.rb", "tests/hp/models/storage/directory_tests.rb", "tests/hp/models/storage/file_tests.rb", "tests/hp/models/storage/files_tests.rb", "tests/hp/requests/block_storage/bootable_volume_tests.rb", "tests/hp/requests/block_storage/snapshot_tests.rb", "tests/hp/requests/block_storage/volume_tests.rb", "tests/hp/requests/block_storage_v2/snapshot_tests.rb", "tests/hp/requests/block_storage_v2/volume_backup_tests.rb", "tests/hp/requests/block_storage_v2/volume_tests.rb", "tests/hp/requests/cdn/container_tests.rb", "tests/hp/requests/compute/address_tests.rb", "tests/hp/requests/compute/flavor_tests.rb", "tests/hp/requests/compute/image_tests.rb", "tests/hp/requests/compute/key_pair_tests.rb", "tests/hp/requests/compute/metadata_tests.rb", "tests/hp/requests/compute/persistent_server_tests.rb", "tests/hp/requests/compute/security_group_rule_tests.rb", "tests/hp/requests/compute/security_group_tests.rb", "tests/hp/requests/compute/server_address_tests.rb", "tests/hp/requests/compute/server_tests.rb", "tests/hp/requests/compute/server_volume_tests.rb", "tests/hp/requests/compute_v2/address_tests.rb", "tests/hp/requests/compute_v2/availability_zone_tests.rb", "tests/hp/requests/compute_v2/flavor_tests.rb", "tests/hp/requests/compute_v2/image_tests.rb", "tests/hp/requests/compute_v2/key_pair_tests.rb", "tests/hp/requests/compute_v2/metadata_tests.rb", "tests/hp/requests/compute_v2/persistent_server_tests.rb", "tests/hp/requests/compute_v2/server_address_tests.rb", "tests/hp/requests/compute_v2/server_security_group_tests.rb", "tests/hp/requests/compute_v2/server_tests.rb", "tests/hp/requests/compute_v2/server_volume_tests.rb", "tests/hp/requests/dns/domain_tests.rb", "tests/hp/requests/dns/records_tests.rb", "tests/hp/requests/lb/algorithms_tests.rb", "tests/hp/requests/lb/limits_tests.rb", "tests/hp/requests/lb/load_balancer_nodes_tests.rb", "tests/hp/requests/lb/load_balancer_tests.rb", "tests/hp/requests/lb/protocols_tests.rb", "tests/hp/requests/lb/versions_tests.rb", "tests/hp/requests/lb/virtual_ips_tests.rb", "tests/hp/requests/network/floating_ip_tests.rb", "tests/hp/requests/network/network_tests.rb", "tests/hp/requests/network/port_tests.rb", "tests/hp/requests/network/router_tests.rb", "tests/hp/requests/network/security_group_rule_tests.rb", "tests/hp/requests/network/security_group_tests.rb", "tests/hp/requests/network/subnet_tests.rb", "tests/hp/requests/storage/container_tests.rb", "tests/hp/requests/storage/object_tests.rb", "tests/hp/storage_tests.rb", "tests/hp/user_agent_tests.rb", "tests/ibm/models/compute/image_tests.rb", "tests/ibm/models/compute/key_tests.rb", "tests/ibm/models/compute/keys_tests.rb", "tests/ibm/models/compute/locations_tests.rb", "tests/ibm/models/compute/server_tests.rb", "tests/ibm/models/compute/servers_tests.rb", "tests/ibm/models/storage/volume_tests.rb", "tests/ibm/requests/compute/address_tests.rb", "tests/ibm/requests/compute/image_tests.rb", "tests/ibm/requests/compute/instance_tests.rb", "tests/ibm/requests/compute/key_tests.rb", "tests/ibm/requests/compute/location_tests.rb", "tests/ibm/requests/compute/vlan_tests.rb", "tests/ibm/requests/storage/volume_tests.rb", "tests/internet_archive/models/storage/directory_tests.rb", "tests/internet_archive/models/storage/file_tests.rb", "tests/internet_archive/models/storage/files_tests.rb", "tests/internet_archive/models/storage/url_tests.rb", "tests/internet_archive/requests/storage/acl_utils_tests.rb", "tests/internet_archive/requests/storage/bucket_tests.rb", "tests/internet_archive/requests/storage/cors_utils_tests.rb", "tests/internet_archive/requests/storage/multipart_upload_tests.rb", "tests/internet_archive/requests/storage/object_tests.rb", "tests/internet_archive/signaturev4_tests.rb", "tests/internet_archive/signed_params_tests.rb", "tests/joyent/models/analytics/field_tests.rb", "tests/joyent/models/analytics/fields_tests.rb", "tests/joyent/models/analytics/instrumentation_tests.rb", "tests/joyent/models/analytics/instrumentations_tests.rb", "tests/joyent/models/analytics/joyent_module_tests.rb", "tests/joyent/models/analytics/joyent_modules_tests.rb", "tests/joyent/models/analytics/metric_tests.rb", "tests/joyent/models/analytics/metrics_tests.rb", "tests/joyent/models/analytics/transformation_tests.rb", "tests/joyent/models/analytics/transformations_tests.rb", "tests/joyent/models/analytics/type_tests.rb", "tests/joyent/models/analytics/types_tests.rb", "tests/joyent/requests/analytics/instrumentation_tests.rb", "tests/joyent/requests/compute/datasets_tests.rb", "tests/joyent/requests/compute/keys_tests.rb", "tests/joyent/requests/compute/machines_tests.rb", "tests/joyent/requests/compute/networks_tests.rb", "tests/joyent/requests/compute/packages_tests.rb", "tests/linode/requests/compute/datacenter_tests.rb", "tests/linode/requests/compute/distribution_tests.rb", "tests/linode/requests/compute/helper.rb", "tests/linode/requests/compute/kernel_tests.rb", "tests/linode/requests/compute/linode_tests.rb", "tests/linode/requests/compute/linodeplans_tests.rb", "tests/linode/requests/compute/nodebalancers_tests.rb", "tests/linode/requests/compute/stackscripts_tests.rb", "tests/linode/requests/dns/dns_tests.rb", "tests/lorem.txt", "tests/ninefold/models/storage/file_update_tests.rb", "tests/ninefold/models/storage/nested_directories_tests.rb", "tests/ninefold/requests/compute/address_tests.rb", "tests/ninefold/requests/compute/async_job_tests.rb", "tests/ninefold/requests/compute/helper.rb", "tests/ninefold/requests/compute/list_tests.rb", "tests/ninefold/requests/compute/load_balancer_tests.rb", "tests/ninefold/requests/compute/nat_tests.rb", "tests/ninefold/requests/compute/network_tests.rb", "tests/ninefold/requests/compute/template_tests.rb", "tests/ninefold/requests/compute/virtual_machine_tests.rb", "tests/opennebula/compute_tests.rb", "tests/opennebula/models/compute/flavor_tests.rb", "tests/opennebula/models/compute/flavors_tests.rb", "tests/opennebula/models/compute/group_tests.rb", "tests/opennebula/models/compute/groups_tests.rb", "tests/opennebula/models/compute/network_tests.rb", "tests/opennebula/models/compute/networks_tests.rb", "tests/opennebula/requests/compute/vm_allocate_tests.rb", "tests/opennebula/requests/compute/vm_disk_snapshot_test.rb", "tests/openvz/helper.rb", "tests/openvz/models/compute/server_tests.rb", "tests/openvz/models/compute/servers_tests.rb", "tests/ovirt/compute_tests.rb", "tests/ovirt/models/compute/cluster_tests.rb", "tests/ovirt/models/compute/clusters_tests.rb", "tests/ovirt/models/compute/interface_tests.rb", "tests/ovirt/models/compute/interfaces_tests.rb", "tests/ovirt/models/compute/server_tests.rb", "tests/ovirt/models/compute/servers_tests.rb", "tests/ovirt/models/compute/template_tests.rb", "tests/ovirt/models/compute/templates_tests.rb", "tests/ovirt/requests/compute/create_vm_tests.rb", "tests/ovirt/requests/compute/destroy_vm_tests.rb", "tests/ovirt/requests/compute/list_datacenters_tests.rb", "tests/ovirt/requests/compute/list_quotas_tests.rb", "tests/ovirt/requests/compute/list_storage_domains_tests.rb", "tests/ovirt/requests/compute/update_vm_tests.rb", "tests/ovirt/requests/compute/update_volume_tests.rb", "tests/rage4/requests/dns/dns_tests.rb", "tests/storage/helper.rb", "tests/storage/models/directories_tests.rb", "tests/storage/models/directory_test.rb", "tests/storage/models/file_tests.rb", "tests/storage/models/files_tests.rb", "tests/vcloud/data/api_+_admin_+_network_+_2", "tests/vcloud/data/api_+_network_+_1", "tests/vcloud/data/api_+_org_+_", "tests/vcloud/data/api_+_org_+_1", "tests/vcloud/data/api_+_sessions", "tests/vcloud/data/api_+_v1.0_+_admin_+_network_+_2", "tests/vcloud/data/api_+_v1.0_+_login", "tests/vcloud/data/api_+_v1.0_+_network_+_1", "tests/vcloud/data/api_+_v1.0_+_network_+_2", "tests/vcloud/data/api_+_v1.0_+_org_+_1", "tests/vcloud/data/api_+_v1.0_+_vApp_+_vapp-1", "tests/vcloud/data/api_+_v1.0_+_vApp_+_vm-1", "tests/vcloud/data/api_+_v1.0_+_vApp_+_vm-2", "tests/vcloud/data/api_+_v1.0_+_vdc_+_1", "tests/vcloud/data/api_+_vApp_+_vapp-1", "tests/vcloud/data/api_+_vApp_+_vm-2", "tests/vcloud/data/api_+_vdc_+_1", "tests/vcloud/models/compute/helper.rb", "tests/vcloud/models/compute/network_tests.rb", "tests/vcloud/models/compute/networks_tests.rb", "tests/vcloud/models/compute/organization_tests.rb", "tests/vcloud/models/compute/organizations_tests.rb", "tests/vcloud/models/compute/server_tests.rb", "tests/vcloud/models/compute/servers_tests.rb", "tests/vcloud/models/compute/vapp_tests.rb", "tests/vcloud/models/compute/vapps_tests.rb", "tests/vcloud/models/compute/vdc_tests.rb", "tests/vcloud/models/compute/vdcs_tests.rb", "tests/vcloud/requests/compute/disk_configure_tests.rb", "tests/vcloud_director/ensure_list_tests.rb", "tests/vcloud_director/fixtures/test.iso", "tests/vcloud_director/fixtures/vapp.xml", "tests/vcloud_director/fixtures/vm.xml", "tests/vcloud_director/generators/compute/compose_vapp_tests.rb", "tests/vcloud_director/models/compute/catalog_items_tests.rb", "tests/vcloud_director/models/compute/catalogs_tests.rb", "tests/vcloud_director/models/compute/helper.rb", "tests/vcloud_director/models/compute/media_tests.rb", "tests/vcloud_director/models/compute/network_tests.rb", "tests/vcloud_director/models/compute/organizations_tests.rb", "tests/vcloud_director/models/compute/tasks_tests.rb", "tests/vcloud_director/models/compute/vapp_life_cycle_tests.rb", "tests/vcloud_director/models/compute/vapp_template_tests.rb", "tests/vcloud_director/models/compute/vapp_tests.rb", "tests/vcloud_director/models/compute/vdcs_tests.rb", "tests/vcloud_director/models/compute/vms_tests.rb", "tests/vcloud_director/requests/compute/admin_tests.rb", "tests/vcloud_director/requests/compute/catalog_tests.rb", "tests/vcloud_director/requests/compute/disk_tests.rb", "tests/vcloud_director/requests/compute/edge_gateway_tests.rb", "tests/vcloud_director/requests/compute/groups_tests.rb", "tests/vcloud_director/requests/compute/helper.rb", "tests/vcloud_director/requests/compute/media_tests.rb", "tests/vcloud_director/requests/compute/network_tests.rb", "tests/vcloud_director/requests/compute/organization_tests.rb", "tests/vcloud_director/requests/compute/ovf_descriptor_tests.rb", "tests/vcloud_director/requests/compute/query_tests.rb", "tests/vcloud_director/requests/compute/schema_helper.rb", "tests/vcloud_director/requests/compute/session_tests.rb", "tests/vcloud_director/requests/compute/supported_systems_tests.rb", "tests/vcloud_director/requests/compute/task_tests.rb", "tests/vcloud_director/requests/compute/users_tests.rb", "tests/vcloud_director/requests/compute/vapp_tests.rb", "tests/vcloud_director/requests/compute/vdc_storage_profile_tests.rb", "tests/vcloud_director/requests/compute/vdc_tests.rb", "tests/vcloud_director/requests/compute/versions_tests.rb", "tests/vcloud_director/requests/compute/vm_tests.rb", "tests/watchr.rb", "tests/zerigo/requests/dns/dns_tests.rb"]
  s.homepage = "http://github.com/fog/fog"
  s.licenses = ["MIT"]
  s.rdoc_options = ["--charset=UTF-8"]
  s.rubyforge_project = "fog"
  s.rubygems_version = "2.5.1"
  s.summary = "brings clouds to you"
  s.test_files = ["spec/fog/account_spec.rb", "spec/fog/billing_spec.rb", "spec/fog/bin/atmos_spec.rb", "spec/fog/bin/aws_spec.rb", "spec/fog/bin/baremetalcloud_spec.rb", "spec/fog/bin/bluebox_spec.rb", "spec/fog/bin/brightbox_spec.rb", "spec/fog/bin/clodo_spec.rb", "spec/fog/bin/cloudsigma_spec.rb", "spec/fog/bin/cloudstack_spec.rb", "spec/fog/bin/digitalocean_spec.rb", "spec/fog/bin/dnsimple_spec.rb", "spec/fog/bin/dnsmadeeasy_spec.rb", "spec/fog/bin/dreamhost_spec.rb", "spec/fog/bin/dynect_spec.rb", "spec/fog/bin/ecloud_spec.rb", "spec/fog/bin/fogdocker_spec.rb", "spec/fog/bin/glesys_spec.rb", "spec/fog/bin/gogrid_spec.rb", "spec/fog/bin/google_spec.rb", "spec/fog/bin/ibm_spec.rb", "spec/fog/bin/internetarchive_spec.rb", "spec/fog/bin/joyent_spec.rb", "spec/fog/bin/linode_spec.rb", "spec/fog/bin/local_spec.rb", "spec/fog/bin/ninefold_spec.rb", "spec/fog/bin/opennebula_spec.rb", "spec/fog/bin/openstack_spec.rb", "spec/fog/bin/openvz_spec.rb", "spec/fog/bin/ovirt_spec.rb", "spec/fog/bin/powerdns_spec.rb", "spec/fog/bin/profitbricks_spec.rb", "spec/fog/bin/rackspace_spec.rb", "spec/fog/bin/rage4_spec.rb", "spec/fog/bin/riakcs_spec.rb", "spec/fog/bin/sakuracloud_spec.rb", "spec/fog/bin/serverlove_spec.rb", "spec/fog/bin/softlayer_spec.rb", "spec/fog/bin/stormondemand_spec.rb", "spec/fog/bin/vcloud_spec.rb", "spec/fog/bin/vclouddirector_spec.rb", "spec/fog/bin/vmfusion_spec.rb", "spec/fog/bin/voxel_spec.rb", "spec/fog/bin/vsphere_spec.rb", "spec/fog/bin/xenserver_spec.rb", "spec/fog/bin/zerigo_spec.rb", "spec/fog/bin_spec.rb", "spec/fog/cdn_spec.rb", "spec/fog/compute_spec.rb", "spec/fog/dns_spec.rb", "spec/fog/identity_spec.rb", "spec/fog/image_spec.rb", "spec/fog/metering_spec.rb", "spec/fog/monitoring_spec.rb", "spec/fog/network_spec.rb", "spec/fog/orchestration_spec.rb", "spec/fog/storage_spec.rb", "spec/fog/support_spec.rb", "spec/fog/volume_spec.rb", "spec/fog/vpn_spec.rb", "spec/fog/xml/connection_spec.rb", "spec/helpers/bin.rb", "spec/spec_helper.rb", "spec/vcloud_director/generators/compute/instantiate_vapp_template_params_spec.rb", "spec/vcloud_director/requests/compute/instantiate_vapp_template_spec.rb", "spec/vcloud_director/spec_helper.rb", "tests/bluebox/requests/blb/helper.rb", "tests/bluebox/requests/blb/lb_tests.rb", "tests/bluebox/requests/compute/block_tests.rb", "tests/bluebox/requests/compute/helper.rb", "tests/bluebox/requests/compute/location_tests.rb", "tests/bluebox/requests/compute/product_tests.rb", "tests/bluebox/requests/compute/template_tests.rb", "tests/bluebox/requests/dns/dns_tests.rb", "tests/clodo/requests/compute/image_tests.rb", "tests/clodo/requests/compute/server_tests.rb", "tests/cloudsigma/models/server_tests.rb", "tests/cloudsigma/models/servers_tests.rb", "tests/cloudsigma/models/volume_tests.rb", "tests/cloudsigma/models/volumes_tests.rb", "tests/cloudsigma/requests/server_tests.rb", "tests/cloudsigma/requests/volumes_tests.rb", "tests/cloudstack/compute/models/disk_offering_tests.rb", "tests/cloudstack/compute/models/egress_firewall_rule_tests.rb", "tests/cloudstack/compute/models/public_ip_address_tests.rb", "tests/cloudstack/compute/models/public_ip_addresses_tests.rb", "tests/cloudstack/compute/models/security_group_rule_tests.rb", "tests/cloudstack/compute/models/security_group_tests.rb", "tests/cloudstack/compute/models/security_groups_tests.rb", "tests/cloudstack/compute/models/server_tests.rb", "tests/cloudstack/compute/models/snapshot_tests.rb", "tests/cloudstack/compute/models/volume_tests.rb", "tests/cloudstack/compute/models/volumes_tests.rb", "tests/cloudstack/requests/disk_offering_tests.rb", "tests/cloudstack/requests/egress_firewall_rule_tests.rb", "tests/cloudstack/requests/firewall_rule_tests.rb", "tests/cloudstack/requests/network_offering_tests.rb", "tests/cloudstack/requests/os_type_tests.rb", "tests/cloudstack/requests/port_forwarding_rule_tests.rb", "tests/cloudstack/requests/public_ip_address_tests.rb", "tests/cloudstack/requests/security_group_tests.rb", "tests/cloudstack/requests/service_offering_tests.rb", "tests/cloudstack/requests/snapshot_tests.rb", "tests/cloudstack/requests/ssh_key_pair_tests.rb", "tests/cloudstack/requests/template_tests.rb", "tests/cloudstack/requests/virtual_machine_tests.rb", "tests/cloudstack/requests/volume_tests.rb", "tests/cloudstack/requests/zone_tests.rb", "tests/cloudstack/signed_params_tests.rb", "tests/compute/helper.rb", "tests/compute/models/flavors_tests.rb", "tests/compute/models/server_tests.rb", "tests/compute/models/servers_tests.rb", "tests/core/attribute_tests.rb", "tests/core/credential_tests.rb", "tests/core/current_machine_tests.rb", "tests/core/mocking_tests.rb", "tests/core/parser_tests.rb", "tests/core/service_tests.rb", "tests/core/timeout_tests.rb", "tests/core/uuid_tests.rb", "tests/core/wait_for_tests.rb", "tests/digitalocean/helper.rb", "tests/digitalocean/requests/compute_v2/list_flavors_tests.rb", "tests/digitalocean/requests/compute_v2/list_images_tests.rb", "tests/digitalocean/requests/compute_v2/list_regions_tests.rb", "tests/digitalocean/requests/compute_v2/server_tests.rb", "tests/dns/helper.rb", "tests/dns/models/record_tests.rb", "tests/dns/models/records_tests.rb", "tests/dns/models/zone_tests.rb", "tests/dns/models/zones_tests.rb", "tests/dnsimple/requests/dns/dns_tests.rb", "tests/dnsmadeeasy/requests/dns/dns_tests.rb", "tests/dreamhost/README.md", "tests/dreamhost/dns_tests.rb", "tests/dreamhost/helper.rb", "tests/dreamhost/models/dns/record_tests.rb", "tests/dreamhost/models/dns/records_tests.rb", "tests/dreamhost/models/dns/zone_tests.rb", "tests/dreamhost/models/dns/zones_tests.rb", "tests/dreamhost/requests/dns/create_record_tests.rb", "tests/dreamhost/requests/dns/delete_record_tests.rb", "tests/dreamhost/requests/dns/list_records_tests.rb", "tests/fogdocker/compute_tests.rb", "tests/fogdocker/models/compute/image_tests.rb", "tests/fogdocker/models/compute/images_tests.rb", "tests/fogdocker/models/compute/server_tests.rb", "tests/fogdocker/models/compute/servers_tests.rb", "tests/fogdocker/requests/compute/api_version_tests.rb", "tests/fogdocker/requests/compute/container_action_tests.rb", "tests/fogdocker/requests/compute/container_commit_tests.rb", "tests/fogdocker/requests/compute/container_create_tests.rb", "tests/fogdocker/requests/compute/container_delete_tests.rb", "tests/fogdocker/requests/compute/image_create_tests.rb", "tests/fogdocker/requests/compute/image_delete_tests.rb", "tests/fogdocker/requests/compute/image_search_tests.rb", "tests/glesys/requests/compute/helper.rb", "tests/glesys/requests/compute/ip_tests.rb", "tests/glesys/requests/compute/server_tests.rb", "tests/glesys/requests/compute/ssh_key_tests.rb", "tests/glesys/requests/compute/template_tests.rb", "tests/go_grid/requests/compute/image_tests.rb", "tests/helper.rb", "tests/helpers/collection_helper.rb", "tests/helpers/compute/flavors_helper.rb", "tests/helpers/compute/server_helper.rb", "tests/helpers/compute/servers_helper.rb", "tests/helpers/formats_helper.rb", "tests/helpers/formats_helper_tests.rb", "tests/helpers/mock_helper.rb", "tests/helpers/model_helper.rb", "tests/helpers/responds_to_helper.rb", "tests/helpers/schema_validator_tests.rb", "tests/helpers/succeeds_helper.rb", "tests/hp/block_storage_tests.rb", "tests/hp/cdn_tests.rb", "tests/hp/compute_tests.rb", "tests/hp/models/block_storage/bootable_volume_tests.rb", "tests/hp/models/block_storage/snapshot_tests.rb", "tests/hp/models/block_storage/volume_tests.rb", "tests/hp/models/block_storage_v2/snapshot_tests.rb", "tests/hp/models/block_storage_v2/snapshots_tests.rb", "tests/hp/models/block_storage_v2/volume_backup_tests.rb", "tests/hp/models/block_storage_v2/volume_backups_tests.rb", "tests/hp/models/block_storage_v2/volume_tests.rb", "tests/hp/models/block_storage_v2/volumes_tests.rb", "tests/hp/models/compute/address_tests.rb", "tests/hp/models/compute/addresses_tests.rb", "tests/hp/models/compute/key_pair_tests.rb", "tests/hp/models/compute/key_pairs_tests.rb", "tests/hp/models/compute/metadata_image_tests.rb", "tests/hp/models/compute/metadata_server_tests.rb", "tests/hp/models/compute/security_group_tests.rb", "tests/hp/models/compute/security_groups_tests.rb", "tests/hp/models/compute_v2/address_tests.rb", "tests/hp/models/compute_v2/addresses_tests.rb", "tests/hp/models/compute_v2/availability_zone_tests.rb", "tests/hp/models/compute_v2/availability_zones_tests.rb", "tests/hp/models/compute_v2/key_pair_tests.rb", "tests/hp/models/compute_v2/key_pairs_tests.rb", "tests/hp/models/compute_v2/metadata_image_tests.rb", "tests/hp/models/compute_v2/metadata_server_tests.rb", "tests/hp/models/compute_v2/server_tests.rb", "tests/hp/models/compute_v2/servers_tests.rb", "tests/hp/models/compute_v2/volume_attachment_tests.rb", "tests/hp/models/compute_v2/volume_attachments_tests.rb", "tests/hp/models/dns/domain_tests.rb", "tests/hp/models/dns/domains_tests.rb", "tests/hp/models/dns/record_tests.rb", "tests/hp/models/dns/records_tests.rb", "tests/hp/models/lb/algorithms_tests.rb", "tests/hp/models/lb/load_balancer_node_tests.rb", "tests/hp/models/lb/load_balancer_nodes_tests.rb", "tests/hp/models/lb/load_balancer_tests.rb", "tests/hp/models/lb/load_balancer_virtual_ips_tests.rb", "tests/hp/models/lb/load_balancers_tests.rb", "tests/hp/models/lb/protocols_tests.rb", "tests/hp/models/network/floating_ip_tests.rb", "tests/hp/models/network/floating_ips_tests.rb", "tests/hp/models/network/network_tests.rb", "tests/hp/models/network/networks_tests.rb", "tests/hp/models/network/port_tests.rb", "tests/hp/models/network/ports_tests.rb", "tests/hp/models/network/router_tests.rb", "tests/hp/models/network/routers_tests.rb", "tests/hp/models/network/security_group_rule_tests.rb", "tests/hp/models/network/security_group_rules_tests.rb", "tests/hp/models/network/security_group_tests.rb", "tests/hp/models/network/security_groups_tests.rb", "tests/hp/models/network/subnet_tests.rb", "tests/hp/models/network/subnets_tests.rb", "tests/hp/models/storage/directories_tests.rb", "tests/hp/models/storage/directory_tests.rb", "tests/hp/models/storage/file_tests.rb", "tests/hp/models/storage/files_tests.rb", "tests/hp/requests/block_storage/bootable_volume_tests.rb", "tests/hp/requests/block_storage/snapshot_tests.rb", "tests/hp/requests/block_storage/volume_tests.rb", "tests/hp/requests/block_storage_v2/snapshot_tests.rb", "tests/hp/requests/block_storage_v2/volume_backup_tests.rb", "tests/hp/requests/block_storage_v2/volume_tests.rb", "tests/hp/requests/cdn/container_tests.rb", "tests/hp/requests/compute/address_tests.rb", "tests/hp/requests/compute/flavor_tests.rb", "tests/hp/requests/compute/image_tests.rb", "tests/hp/requests/compute/key_pair_tests.rb", "tests/hp/requests/compute/metadata_tests.rb", "tests/hp/requests/compute/persistent_server_tests.rb", "tests/hp/requests/compute/security_group_rule_tests.rb", "tests/hp/requests/compute/security_group_tests.rb", "tests/hp/requests/compute/server_address_tests.rb", "tests/hp/requests/compute/server_tests.rb", "tests/hp/requests/compute/server_volume_tests.rb", "tests/hp/requests/compute_v2/address_tests.rb", "tests/hp/requests/compute_v2/availability_zone_tests.rb", "tests/hp/requests/compute_v2/flavor_tests.rb", "tests/hp/requests/compute_v2/image_tests.rb", "tests/hp/requests/compute_v2/key_pair_tests.rb", "tests/hp/requests/compute_v2/metadata_tests.rb", "tests/hp/requests/compute_v2/persistent_server_tests.rb", "tests/hp/requests/compute_v2/server_address_tests.rb", "tests/hp/requests/compute_v2/server_security_group_tests.rb", "tests/hp/requests/compute_v2/server_tests.rb", "tests/hp/requests/compute_v2/server_volume_tests.rb", "tests/hp/requests/dns/domain_tests.rb", "tests/hp/requests/dns/records_tests.rb", "tests/hp/requests/lb/algorithms_tests.rb", "tests/hp/requests/lb/limits_tests.rb", "tests/hp/requests/lb/load_balancer_nodes_tests.rb", "tests/hp/requests/lb/load_balancer_tests.rb", "tests/hp/requests/lb/protocols_tests.rb", "tests/hp/requests/lb/versions_tests.rb", "tests/hp/requests/lb/virtual_ips_tests.rb", "tests/hp/requests/network/floating_ip_tests.rb", "tests/hp/requests/network/network_tests.rb", "tests/hp/requests/network/port_tests.rb", "tests/hp/requests/network/router_tests.rb", "tests/hp/requests/network/security_group_rule_tests.rb", "tests/hp/requests/network/security_group_tests.rb", "tests/hp/requests/network/subnet_tests.rb", "tests/hp/requests/storage/container_tests.rb", "tests/hp/requests/storage/object_tests.rb", "tests/hp/storage_tests.rb", "tests/hp/user_agent_tests.rb", "tests/ibm/models/compute/image_tests.rb", "tests/ibm/models/compute/key_tests.rb", "tests/ibm/models/compute/keys_tests.rb", "tests/ibm/models/compute/locations_tests.rb", "tests/ibm/models/compute/server_tests.rb", "tests/ibm/models/compute/servers_tests.rb", "tests/ibm/models/storage/volume_tests.rb", "tests/ibm/requests/compute/address_tests.rb", "tests/ibm/requests/compute/image_tests.rb", "tests/ibm/requests/compute/instance_tests.rb", "tests/ibm/requests/compute/key_tests.rb", "tests/ibm/requests/compute/location_tests.rb", "tests/ibm/requests/compute/vlan_tests.rb", "tests/ibm/requests/storage/volume_tests.rb", "tests/internet_archive/models/storage/directory_tests.rb", "tests/internet_archive/models/storage/file_tests.rb", "tests/internet_archive/models/storage/files_tests.rb", "tests/internet_archive/models/storage/url_tests.rb", "tests/internet_archive/requests/storage/acl_utils_tests.rb", "tests/internet_archive/requests/storage/bucket_tests.rb", "tests/internet_archive/requests/storage/cors_utils_tests.rb", "tests/internet_archive/requests/storage/multipart_upload_tests.rb", "tests/internet_archive/requests/storage/object_tests.rb", "tests/internet_archive/signaturev4_tests.rb", "tests/internet_archive/signed_params_tests.rb", "tests/joyent/models/analytics/field_tests.rb", "tests/joyent/models/analytics/fields_tests.rb", "tests/joyent/models/analytics/instrumentation_tests.rb", "tests/joyent/models/analytics/instrumentations_tests.rb", "tests/joyent/models/analytics/joyent_module_tests.rb", "tests/joyent/models/analytics/joyent_modules_tests.rb", "tests/joyent/models/analytics/metric_tests.rb", "tests/joyent/models/analytics/metrics_tests.rb", "tests/joyent/models/analytics/transformation_tests.rb", "tests/joyent/models/analytics/transformations_tests.rb", "tests/joyent/models/analytics/type_tests.rb", "tests/joyent/models/analytics/types_tests.rb", "tests/joyent/requests/analytics/instrumentation_tests.rb", "tests/joyent/requests/compute/datasets_tests.rb", "tests/joyent/requests/compute/keys_tests.rb", "tests/joyent/requests/compute/machines_tests.rb", "tests/joyent/requests/compute/networks_tests.rb", "tests/joyent/requests/compute/packages_tests.rb", "tests/linode/requests/compute/datacenter_tests.rb", "tests/linode/requests/compute/distribution_tests.rb", "tests/linode/requests/compute/helper.rb", "tests/linode/requests/compute/kernel_tests.rb", "tests/linode/requests/compute/linode_tests.rb", "tests/linode/requests/compute/linodeplans_tests.rb", "tests/linode/requests/compute/nodebalancers_tests.rb", "tests/linode/requests/compute/stackscripts_tests.rb", "tests/linode/requests/dns/dns_tests.rb", "tests/lorem.txt", "tests/ninefold/models/storage/file_update_tests.rb", "tests/ninefold/models/storage/nested_directories_tests.rb", "tests/ninefold/requests/compute/address_tests.rb", "tests/ninefold/requests/compute/async_job_tests.rb", "tests/ninefold/requests/compute/helper.rb", "tests/ninefold/requests/compute/list_tests.rb", "tests/ninefold/requests/compute/load_balancer_tests.rb", "tests/ninefold/requests/compute/nat_tests.rb", "tests/ninefold/requests/compute/network_tests.rb", "tests/ninefold/requests/compute/template_tests.rb", "tests/ninefold/requests/compute/virtual_machine_tests.rb", "tests/opennebula/compute_tests.rb", "tests/opennebula/models/compute/flavor_tests.rb", "tests/opennebula/models/compute/flavors_tests.rb", "tests/opennebula/models/compute/group_tests.rb", "tests/opennebula/models/compute/groups_tests.rb", "tests/opennebula/models/compute/network_tests.rb", "tests/opennebula/models/compute/networks_tests.rb", "tests/opennebula/requests/compute/vm_allocate_tests.rb", "tests/opennebula/requests/compute/vm_disk_snapshot_test.rb", "tests/openvz/helper.rb", "tests/openvz/models/compute/server_tests.rb", "tests/openvz/models/compute/servers_tests.rb", "tests/ovirt/compute_tests.rb", "tests/ovirt/models/compute/cluster_tests.rb", "tests/ovirt/models/compute/clusters_tests.rb", "tests/ovirt/models/compute/interface_tests.rb", "tests/ovirt/models/compute/interfaces_tests.rb", "tests/ovirt/models/compute/server_tests.rb", "tests/ovirt/models/compute/servers_tests.rb", "tests/ovirt/models/compute/template_tests.rb", "tests/ovirt/models/compute/templates_tests.rb", "tests/ovirt/requests/compute/create_vm_tests.rb", "tests/ovirt/requests/compute/destroy_vm_tests.rb", "tests/ovirt/requests/compute/list_datacenters_tests.rb", "tests/ovirt/requests/compute/list_quotas_tests.rb", "tests/ovirt/requests/compute/list_storage_domains_tests.rb", "tests/ovirt/requests/compute/update_vm_tests.rb", "tests/ovirt/requests/compute/update_volume_tests.rb", "tests/rage4/requests/dns/dns_tests.rb", "tests/storage/helper.rb", "tests/storage/models/directories_tests.rb", "tests/storage/models/directory_test.rb", "tests/storage/models/file_tests.rb", "tests/storage/models/files_tests.rb", "tests/vcloud/data/api_+_admin_+_network_+_2", "tests/vcloud/data/api_+_network_+_1", "tests/vcloud/data/api_+_org_+_", "tests/vcloud/data/api_+_org_+_1", "tests/vcloud/data/api_+_sessions", "tests/vcloud/data/api_+_v1.0_+_admin_+_network_+_2", "tests/vcloud/data/api_+_v1.0_+_login", "tests/vcloud/data/api_+_v1.0_+_network_+_1", "tests/vcloud/data/api_+_v1.0_+_network_+_2", "tests/vcloud/data/api_+_v1.0_+_org_+_1", "tests/vcloud/data/api_+_v1.0_+_vApp_+_vapp-1", "tests/vcloud/data/api_+_v1.0_+_vApp_+_vm-1", "tests/vcloud/data/api_+_v1.0_+_vApp_+_vm-2", "tests/vcloud/data/api_+_v1.0_+_vdc_+_1", "tests/vcloud/data/api_+_vApp_+_vapp-1", "tests/vcloud/data/api_+_vApp_+_vm-2", "tests/vcloud/data/api_+_vdc_+_1", "tests/vcloud/models/compute/helper.rb", "tests/vcloud/models/compute/network_tests.rb", "tests/vcloud/models/compute/networks_tests.rb", "tests/vcloud/models/compute/organization_tests.rb", "tests/vcloud/models/compute/organizations_tests.rb", "tests/vcloud/models/compute/server_tests.rb", "tests/vcloud/models/compute/servers_tests.rb", "tests/vcloud/models/compute/vapp_tests.rb", "tests/vcloud/models/compute/vapps_tests.rb", "tests/vcloud/models/compute/vdc_tests.rb", "tests/vcloud/models/compute/vdcs_tests.rb", "tests/vcloud/requests/compute/disk_configure_tests.rb", "tests/vcloud_director/ensure_list_tests.rb", "tests/vcloud_director/fixtures/test.iso", "tests/vcloud_director/fixtures/vapp.xml", "tests/vcloud_director/fixtures/vm.xml", "tests/vcloud_director/generators/compute/compose_vapp_tests.rb", "tests/vcloud_director/models/compute/catalog_items_tests.rb", "tests/vcloud_director/models/compute/catalogs_tests.rb", "tests/vcloud_director/models/compute/helper.rb", "tests/vcloud_director/models/compute/media_tests.rb", "tests/vcloud_director/models/compute/network_tests.rb", "tests/vcloud_director/models/compute/organizations_tests.rb", "tests/vcloud_director/models/compute/tasks_tests.rb", "tests/vcloud_director/models/compute/vapp_life_cycle_tests.rb", "tests/vcloud_director/models/compute/vapp_template_tests.rb", "tests/vcloud_director/models/compute/vapp_tests.rb", "tests/vcloud_director/models/compute/vdcs_tests.rb", "tests/vcloud_director/models/compute/vms_tests.rb", "tests/vcloud_director/requests/compute/admin_tests.rb", "tests/vcloud_director/requests/compute/catalog_tests.rb", "tests/vcloud_director/requests/compute/disk_tests.rb", "tests/vcloud_director/requests/compute/edge_gateway_tests.rb", "tests/vcloud_director/requests/compute/groups_tests.rb", "tests/vcloud_director/requests/compute/helper.rb", "tests/vcloud_director/requests/compute/media_tests.rb", "tests/vcloud_director/requests/compute/network_tests.rb", "tests/vcloud_director/requests/compute/organization_tests.rb", "tests/vcloud_director/requests/compute/ovf_descriptor_tests.rb", "tests/vcloud_director/requests/compute/query_tests.rb", "tests/vcloud_director/requests/compute/schema_helper.rb", "tests/vcloud_director/requests/compute/session_tests.rb", "tests/vcloud_director/requests/compute/supported_systems_tests.rb", "tests/vcloud_director/requests/compute/task_tests.rb", "tests/vcloud_director/requests/compute/users_tests.rb", "tests/vcloud_director/requests/compute/vapp_tests.rb", "tests/vcloud_director/requests/compute/vdc_storage_profile_tests.rb", "tests/vcloud_director/requests/compute/vdc_tests.rb", "tests/vcloud_director/requests/compute/versions_tests.rb", "tests/vcloud_director/requests/compute/vm_tests.rb", "tests/watchr.rb", "tests/zerigo/requests/dns/dns_tests.rb"]

  if s.respond_to? :specification_version then
    s.specification_version = 2

    if Gem::Version.new(Gem::VERSION) >= Gem::Version.new('1.2.0') then
      s.add_runtime_dependency(%q<fog-core>, ["~> 1.32"])
      s.add_runtime_dependency(%q<fog-json>, [">= 0"])
      s.add_runtime_dependency(%q<fog-xml>, ["~> 0.1.1"])
      s.add_runtime_dependency(%q<ipaddress>, ["~> 0.5"])
      s.add_runtime_dependency(%q<fog-aws>, [">= 0.6.0"])
      s.add_runtime_dependency(%q<fog-google>, ["<= 0.1.0"])
      s.add_runtime_dependency(%q<fog-openstack>, [">= 0"])
      s.add_runtime_dependency(%q<fog-rackspace>, [">= 0"])
      s.add_runtime_dependency(%q<fog-vsphere>, [">= 0.4.0"])
      s.add_runtime_dependency(%q<fog-xenserver>, [">= 0"])
      s.add_development_dependency(%q<docker-api>, [">= 1.13.6"])
      s.add_development_dependency(%q<fission>, [">= 0"])
      s.add_development_dependency(%q<mime-types>, ["<= 2.99.1"])
      s.add_development_dependency(%q<minitest>, [">= 0"])
      s.add_development_dependency(%q<minitest-stub-const>, [">= 0"])
      s.add_development_dependency(%q<opennebula>, [">= 0"])
      s.add_development_dependency(%q<pry>, [">= 0"])
      s.add_development_dependency(%q<rake>, [">= 0"])
      s.add_development_dependency(%q<rbovirt>, ["= 0.0.32"])
      s.add_development_dependency(%q<rbvmomi>, [">= 0"])
      s.add_development_dependency(%q<rubocop>, [">= 0"])
      s.add_development_dependency(%q<shindo>, ["~> 0.3.4"])
      s.add_development_dependency(%q<simplecov>, [">= 0"])
      s.add_development_dependency(%q<thor>, [">= 0"])
      s.add_development_dependency(%q<yard>, [">= 0"])
      s.add_development_dependency(%q<rspec-core>, [">= 0"])
      s.add_development_dependency(%q<rspec-expectations>, [">= 0"])
      s.add_development_dependency(%q<vcr>, [">= 0"])
      s.add_development_dependency(%q<webmock>, ["~> 1.22.2"])
    else
      s.add_dependency(%q<fog-core>, ["~> 1.32"])
      s.add_dependency(%q<fog-json>, [">= 0"])
      s.add_dependency(%q<fog-xml>, ["~> 0.1.1"])
      s.add_dependency(%q<ipaddress>, ["~> 0.5"])
      s.add_dependency(%q<fog-aws>, [">= 0.6.0"])
      s.add_dependency(%q<fog-google>, ["<= 0.1.0"])
      s.add_dependency(%q<fog-openstack>, [">= 0"])
      s.add_dependency(%q<fog-rackspace>, [">= 0"])
      s.add_dependency(%q<fog-vsphere>, [">= 0.4.0"])
      s.add_dependency(%q<fog-xenserver>, [">= 0"])
      s.add_dependency(%q<docker-api>, [">= 1.13.6"])
      s.add_dependency(%q<fission>, [">= 0"])
      s.add_dependency(%q<mime-types>, ["<= 2.99.1"])
      s.add_dependency(%q<minitest>, [">= 0"])
      s.add_dependency(%q<minitest-stub-const>, [">= 0"])
      s.add_dependency(%q<opennebula>, [">= 0"])
      s.add_dependency(%q<pry>, [">= 0"])
      s.add_dependency(%q<rake>, [">= 0"])
      s.add_dependency(%q<rbovirt>, ["= 0.0.32"])
      s.add_dependency(%q<rbvmomi>, [">= 0"])
      s.add_dependency(%q<rubocop>, [">= 0"])
      s.add_dependency(%q<shindo>, ["~> 0.3.4"])
      s.add_dependency(%q<simplecov>, [">= 0"])
      s.add_dependency(%q<thor>, [">= 0"])
      s.add_dependency(%q<yard>, [">= 0"])
      s.add_dependency(%q<rspec-core>, [">= 0"])
      s.add_dependency(%q<rspec-expectations>, [">= 0"])
      s.add_dependency(%q<vcr>, [">= 0"])
      s.add_dependency(%q<webmock>, ["~> 1.22.2"])
    end
  else
    s.add_dependency(%q<fog-core>, ["~> 1.32"])
    s.add_dependency(%q<fog-json>, [">= 0"])
    s.add_dependency(%q<fog-xml>, ["~> 0.1.1"])
    s.add_dependency(%q<ipaddress>, ["~> 0.5"])
    s.add_dependency(%q<fog-aws>, [">= 0.6.0"])
    s.add_dependency(%q<fog-google>, ["<= 0.1.0"])
    s.add_dependency(%q<fog-openstack>, [">= 0"])
    s.add_dependency(%q<fog-rackspace>, [">= 0"])
    s.add_dependency(%q<fog-vsphere>, [">= 0.4.0"])
    s.add_dependency(%q<fog-xenserver>, [">= 0"])
    s.add_dependency(%q<docker-api>, [">= 1.13.6"])
    s.add_dependency(%q<fission>, [">= 0"])
    s.add_dependency(%q<mime-types>, ["<= 2.99.1"])
    s.add_dependency(%q<minitest>, [">= 0"])
    s.add_dependency(%q<minitest-stub-const>, [">= 0"])
    s.add_dependency(%q<opennebula>, [">= 0"])
    s.add_dependency(%q<pry>, [">= 0"])
    s.add_dependency(%q<rake>, [">= 0"])
    s.add_dependency(%q<rbovirt>, ["= 0.0.32"])
    s.add_dependency(%q<rbvmomi>, [">= 0"])
    s.add_dependency(%q<rubocop>, [">= 0"])
    s.add_dependency(%q<shindo>, ["~> 0.3.4"])
    s.add_dependency(%q<simplecov>, [">= 0"])
    s.add_dependency(%q<thor>, [">= 0"])
    s.add_dependency(%q<yard>, [">= 0"])
    s.add_dependency(%q<rspec-core>, [">= 0"])
    s.add_dependency(%q<rspec-expectations>, [">= 0"])
    s.add_dependency(%q<vcr>, [">= 0"])
    s.add_dependency(%q<webmock>, ["~> 1.22.2"])
  end
end

